/*!
 * System Runtime
 * 
 * https://designfirst.io/systemruntime/
 * 
 * Copyright 2022 Erwan Carriou
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var e={ID:"_id",NAME:"_name",DESCRIPTION:"_description",INHERIT:"_inherit",CLASS:"_class",CORE:"_core",INTERNAL_NAMES:["_id","_name","_inherit","_description","_class","_core"],PROPERTY_TYPE:"property",COLLECTION_TYPE:"collection",LINK_TYPE:"link",METHOD_TYPE:"method",EVENT_TYPE:"event",INTERNAL_TYPES:["property","collection","link","method","event"],DEFAULT_TYPES:["boolean","string","number","object","function","array","date","any"],SCHEMA_DEFINITION:{_id:{type:"string",mandatory:!0},_name:{type:"string",mandatory:!0},_inherit:{type:["string"],mandatory:!1,default:["_Component"]},_class:{type:"boolean",mandatory:!1},_core:{type:"boolean",mandatory:!1},_description:{type:"string",mandatory:!1}},MODEL_DEFINITION:{_id:{type:"string",mandatory:!0},_name:{type:"string",mandatory:!0},_inherit:{type:["string"],mandatory:!1},_class:{type:"boolean",mandatory:!1},_core:{type:"boolean",mandatory:!1},_description:{type:"string",mandatory:!1}},TYPE_DEFINITION:{_id:{type:"string",mandatory:!0},name:{type:"string",mandatory:!0},type:{type:"string",mandatory:!0},schema:{type:"object",mandatory:!1},value:{type:["any"],mandatory:!1},core:{type:"boolean",mandatory:!1},description:{type:"string",mandatory:!1}}};let t=null,n={currentLevel:"warn",level:function(e){return e&&(this.currentLevel=e),this.currentLevel},debug:function(e){"debug"===this.currentLevel&&console.log("runtime: "+e)},info:function(e){"info"!==this.currentLevel&&"debug"!==this.currentLevel||console.info("runtime: "+e)},warn:function(e){"info"!==this.currentLevel&&"warn"!==this.currentLevel&&"debug"!==this.currentLevel||console.warn("runtime: "+e)},error:function(e){"info"!==this.currentLevel&&"warn"!==this.currentLevel&&"debug"!==this.currentLevel&&"error"!==this.currentLevel||console.error("runtime: "+e)}};function a(){let a="",r=[],o=null;return J.getModel("_Logger")?(r=Ee.collections._Logger.find(),r.length?(a=r[0][e.ID],fe.get(a)?(t=fe.get(a),o=t):o=n):o=n):o=n,o}var r={level:function(e){},unknownProperty:function(t,n){let r="";r=n[e.NAME]?"unknown property '"+t+"' for the definition of '"+n[e.NAME]+"'":"unknown property '"+t+"' for a model",a().warn(r)},invalidPropertyType:function(e,t,n){let r=n&&n.constructor?n.constructor.name:typeof n;a().warn("invalid value for property '"+e+"': expected type '"+t+"' instead of type '"+r+"'")},invalidEnumValue:function(e,t){a().warn("'"+e+"' is an invalid value for the type enum '"+t+"'")},invalidClassName:function(e,t,n){a().warn("invalid component '"+e+"' for a collection: expected a component of class '"+t+"' instead of '"+n+"'")},missingProperty:function(e){a().warn("property '"+e+"' is missing")},missingImplementation:function(e){a().warn("schema '"+e+"' is missing")},invalidTypeImp:function(e,t){a().error("the property '"+e+"' of "+t+" model is invalid")},missingPropertyImp:function(e,t){a().warn("missing property '"+e+"' in the model '"+t+"'")},unknownPropertyImp:function(e,t){a().error("the model '"+t+"' has an unknown property '"+e+"'")},invalidTypeDefinition:function(e){a().warn("the type '"+e+"' is not valid")},invalidPropertyName:function(e,t,n,r,o){let i="",s="";"Function"!==t&&(i=" ("+t+" class)"),"string"==typeof o?(s=r&&r.constructor?r.constructor.name:typeof r,a().warn("invalid value for property '"+n+"' on component '"+e+"'"+i+": expected type '"+o+"' instead of type '"+s+"'")):(s=o&&o.constructor?o.constructor.name:typeof o,a().warn("invalid value for property '"+n+"' on component '"+i+": expected type 'string' instead of type '"+s+"'"))},readOnlyProperty:function(e,t,n){let r="";"Function"!==t&&(r=" ("+t+" class)"),a().warn("can not set read-only property '"+n+"' on component '"+e+"'"+r)},invalidDocumentOnDbInsert:function(e,t){a().warn("invalid document '"+JSON.stringify(e).replace(/,/g,", ")+"' ("+t+" collection)")},invalidPropertyTypeOnDbUpdate:function(e,t,n,r,o){a().warn("invalid type for the property '"+n+"' of the document '"+t+"' ("+e+" collection) with the value '"+JSON.stringify(r)+"': expected type '"+o+"'")},unknownPropertyOnDbUpdate:function(e,t,n){a().warn("unknown property '"+e+"' for document '"+n+"' ("+t+" collection)")},unknownMethod:function(e,t){a().warn("try to call an unknown action '"+t+"' for the class '"+e+"'")},invalidCollectionName:function(e){a().warn("invalid name for the collection '"+e+"': there is no schema '"+e+"'")},invalidResultType:function(e,t,n,r,o){let i="";"Function"!==t&&(i=" ("+t+" class)"),a().warn("invalid type for the result of action '"+n+"' on component '"+e+"'"+i+": expected type '"+r+"' instead of type '"+o+"'")},unknownComponent:function(e,t){a().warn("unkown class name '"+e+"' for component '"+t+"'")},invalidParamNumber:function(e,t,n){let r="";"Function"!==t&&(r=" ("+t+" class)"),a().warn("invalid number of parameters when calling the action '"+n+"' on component '"+e+"'"+r)},invalidParamType:function(e,t,n,r){let o="";"Function"!==t&&(o=" ("+t+" class)"),void 0!==r?a().warn("invalid type for the parameter '"+r+"' when calling the action '"+n+"' on component '"+e+"'"+o):a().warn("invalid type for a parameter when calling the action '"+n+"' on component '"+e+"'"+o)},behaviorNotUnique:function(e,t){a().warn("try to add more than one action for the state '"+t+"' on class '"+e+"'")},invalidStateOn:function(e,t){a().warn("try to add an action to an unkwown state '"+t+"' on class '"+e+"'")},invalidStateOff:function(e,t){a().warn("try to remove an action from an unkwown state '"+t+"' on class '"+e+"'")},masterSystemNotFound:function(){a().warn("can not export the database because no system was defined")},invalidType:function(e,t,n){let r=e&&t.constructor?t.constructor.name:typeof t;a().warn("invalid value for property '"+e+"': expected type '"+n+"' instead of type '"+r+"'")},invalidConfiguration:function(e,t){a().warn("invalid type for '"+JSON.stringify(e)+"': expected '"+t+"'")},unknownType:function(e){a().warn("unknown type for value '"+JSON.stringify(e)+"'")},unknownPath:function(e,t){a().warn("the path '"+e+"' has an unkown subpath '"+t+"'")},canNotYetValidate:function(e,t){a().debug("can not yet validate if the document '"+e+"' is compliant with "+t+" model")},invalidChannelEvent:function(e,t,n){a().warn("invalid type for the message '"+JSON.stringify(e)+"': expected type '"+n+"' for event '"+t+"'")},invalidParamNumberMethodOn:function(e,t,n){let r="";"Function"!==t&&(r=" ("+t+" class)"),a().warn("invalid number of parameters when adding an action for the state '"+n+"' on component '"+e+"'"+r)},updateUuid:function(e,t,n){n?a().warn("try to update a component of id '"+e+"' with the new id '"+t+"' that is already used"):a().warn("try to update a component of id '"+e+"' with the new id '"+t+"'")},invalidUseOfComponent:function(e){a().warn("try to change the state of the destroyed component '"+e+"'")},invalidSchema:function(e){a().warn("the schema '"+e+"' is not valid, it has been removed from the metamodel")},invalidModel:function(e){a().warn("the model '"+e+"' is not valid, it has been removed from the metamodel")},invalidParameters:function(e,t){let n=t&&t._id?t._id:"";a().warn("the parameters for creating '"+n+"' component ("+e+" model) are not compliant with the model")},destroyedComponentCall:function(e,t){a().warn("trying to get the property '"+e+"' on the destroyed component '"+t+"'")},invalidConctructorParameters:function(e,t){a().warn("the constructor parameter '"+JSON.stringify(e).replace(/,/g,", ")+"' for creating a component of class '"+t+"' is not an object")},unknownModel:function(e){a().warn("the model '"+e+"' does not exist")},missingSchema:function(e){a().warn("the schema '"+e+"' is missing")},cyclicDependency:function(e){e?a().error("a cyclic inheritance dependency with the schema '"+e+"’ has been found, please check the '_inherit' property of this schema"):a().error("a cyclic inheritance dependency has been found, please check the '_inherit' properties of the schemas")},invalidEnumType:function(e,t,n){let r="";void 0!==n&&n!==typeof e?(r=e&&e.constructor?e.constructor.name:typeof e,a().warn("invalid type for the type '"+t+"': expected type '"+n+"' instead of type '"+r+"'")):a().warn("invalid type for the type '"+t+"'")},loadSchema:function(e){a().debug("load schema '"+e+"'")},loadModel:function(e){a().debug("load model '"+e+"'")},loadType:function(e){a().debug("load type '"+e+"'")},generatingSchema:function(e){a().debug("generating "+e+" schema ...")},checkModel:function(e){a().debug("analyzing "+e+" model...")},createClass:function(e){a().debug(e+" class has been created")},initDb:function(){a().debug("initializing data store...")},actionInvokeError:function(e,t,n,r){"Function"!==n?a().error("error when calling the action '"+e+"' on component '"+t+"' ("+n+" class): "+r):a().error("error when calling the action '"+e+"' on component '"+t+"': "+r)},invalidSchemaPropertyName:function(e,t){a().warn("invalid name '"+t+"' for schema '"+e+"': a property name can not begin with '_'")},invalidSchemaProperty:function(e,t){a().warn("invalid property '"+t+"' for schema '"+e+"': only 'property', 'link', 'collection', 'method' and 'event' are allowed")},invalidPropertyFormat:function(e){a().warn("invalid format for a definition of a property: '"+e+"' is not an object")},invalidState:function(e,t){a().warn("invalid state '"+t+"' for the model '"+e+"'")},unknownContext:function(e,t){a().warn("invoke the action '"+t+"' on the class '"+e+"' without a valid context")},historyDocumentInserted:function(e,t,n){a().debug("Created component of id '"+e+"' ('"+t+" collection) with document '"+n+"'")},historyDocumentRemoved:function(e,t){a().debug("Destroyed component of id '"+e+"' ("+t+" collection)")},historyDocumentUpdated:function(e,t,n,r){a().debug("Updated field '"+n+"' of component of id '"+e+"' with value '"+r+"' ("+t+" collection)")},invalidCollectionItem:function(e,t,n,r,o){let i="";"Function"!==t&&(i=" ("+t+" class)"),a().warn("invalid value for property '"+n+"' on component '"+e+"'"+i+": expected type '"+o+"' for all items of the collection '"+JSON.stringify(r)+"'")}};let o=null;var i={isRuntime:function(){let e=!1;return Ee.collections._Runtime&&Ee.collections._Runtime.find().length&&(e=!0),e},getRuntime:function(){let t="",n=Ee.collections._Runtime.find();return!o&&n[0]&&(t=n[0][e.ID],o=fe.get(t)),o},isOnNode:function(){let e=!1;return"undefined"==typeof window&&"undefined"!=typeof global&&(e=!0),e},generateId:function(){return function(){let e="abcdef";return e.charAt(Math.floor(Math.random()*e.length))}()+"xxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,(function(e){let t=16*Math.random()|0;return("x"===e?t:3&t|8).toString(16)}))}};let s={inheritance:{},inheritanceTree:{},schemas:{},generatedSchemas:{},models:{},generatedModels:{},states:{},type:{}};function l(t){let n=!0;return-1===e.INTERNAL_NAMES.indexOf(t)&&(n=!1),n}function c(){let t="",n="",a="",o={},i=null,c="",d=null,u=null,m=null,y={},f={},p=[],h=0,g=0,b=0,_=0,v=[];for(a in s.generatedSchemas){for(t in o=s.generatedSchemas[a],y={_name:o[e.NAME]},void 0!==o[e.CORE]&&(y[e.CORE]=o[e.CORE]),Array.isArray(o[e.INHERIT])&&(y[e.INHERIT]=o[e.INHERIT]),void 0!==o[e.CLASS]&&(y[e.CLASS]=o[e.CLASS]),void 0!==o[e.DESCRIPTION]&&(y[e.DESCRIPTION]=o[e.DESCRIPTION]),o)l(t)||0!==t.indexOf("_")||r.invalidSchemaPropertyName(o[e.NAME],t);for(t in o)switch(!0){case"property"===o[t]:y[t]={type:"any",readOnly:!1,mandatory:!1,default:"",description:t,label:t};break;case"link"===o[t]:y[t]={type:"_Component",readOnly:!1,mandatory:!1,default:"",description:t,label:t};break;case"method"===o[t]:y[t]={params:[{name:"param1",type:"any",mandatory:!1,default:null},{name:"param2",type:"any",mandatory:!1,default:null},{name:"param3",type:"any",mandatory:!1,default:null}],result:"any",description:t};break;case"event"===o[t]:y[t]={params:[{name:"param1",type:"any",mandatory:!1,default:null},{name:"param2",type:"any",mandatory:!1,default:null},{name:"param3",type:"any",mandatory:!1,default:null}],description:t};break;case"collection"===o[t]:y[t]={type:["_Component"],readOnly:!1,mandatory:!1,default:[],description:t,label:t};break;default:l(t)||r.invalidSchemaProperty(o[e.NAME],t)}s.generatedModels[y[e.NAME]]=y}for(c in s.generatedModels)y=s.generatedModels[c],n=y[e.NAME],u=s.models[n],u&&(f=S(u,y),s.generatedModels[n]=f);for(v=function(){let e=[],t={},n=[],a="",r=0;for(a in s.inheritanceTree)r=s.inheritanceTree[a].length,void 0===t[r]&&(t[r]=[]),t[r].push(a);return n=Object.keys(t).sort(),n.forEach((function(n){t[n].forEach((function(t){e.push(t)}))})),e}(),_=v.length,g=0;g<_;g++)if(c=v[g],y=s.generatedModels[c],y){for(p=R(c),p.reverse(),h=p.length,b=0;b<h;b++)n=p[b],d=s.generatedModels[n],d&&(f=S(d,y),s.generatedModels[c]=f);u=s.models[c],u&&(f=S(u,s.generatedModels[c]),s.generatedModels[c]=f)}for(a in s.generatedSchemas)i=s.generatedSchemas[a],Ee.collections._GeneratedSchema.insert(i);for(c in s.generatedModels)m=s.generatedModels[c],Ee.collections._GeneratedModel.insert(m)}function d(){let e="",t=[],n=[];function a(e,t){let n=0,a=0,r=[];for(a=t.length,n=0;n<a;n++)0===t[n].indexOf(e)&&(r=t[n],r.reverse(),r.pop(),r.reverse(),t[n]=r)}function o(e,t){let n=!0,a=0,r=0;for(r=t.length,a=0;a<r;a++)t[a].indexOf(e)>0&&(n=!1);return n}function i(e){let t=0,n=0,r=[];for(n=e.length,t=0;t<n;t++)if(o(e[t][0],e)){r.push(e[t][0]),a(e[t][0],e);break}return r}function l(e){let t=[],n=[],a=0,o=0;function c(e,t){let n=!1;return Array.isArray(s.inheritance[t])&&-1!==s.inheritance[t].indexOf(e)&&(r.cyclicDependency(e),n=!0),n}for(Array.isArray(s.inheritance[e])?n=s.inheritance[e].slice():r.missingSchema(e),o=n.length,a=0;a<o;a++)if(c(e,n[a])){n=[];break}return t=n.length?[e].concat(function(e){let t=[],n=[];for(n=i(e);void 0!==n[0];)t=t.concat(n),n=i(e);return function(e){let t=0,n=0,a=!0;for(n=e.length,t=0;t<n;t++)e[t].length&&(a=!1);return a}(e)||r.cyclicDependency(),t}(n.map(l).concat([n]))):[e],t}for(e in s.inheritance)t=l(e),n=t.reverse(),n.pop(),n.length&&(s.inheritanceTree[e]=n)}function u(e){let t={},n=s.schemas[e],a=s.inheritanceTree[e],r=0,o=0,i=null,l="";for(a&&(r=a.length,a.reverse()),o=0;o<r;o++)for(l in i=s.schemas[a[o]],i)0!==l.indexOf("_")&&(t[l]=i[l]);for(l in n)t[l]=n[l];return t}function m(t,n){let a="",o=null;for(a in n)a!==e.ID&&a!==e.NAME&&a!==e.DESCRIPTION&&a!==e.INHERIT&&a!==e.CLASS&&a!==e.CORE&&(void 0!==t[a]?(o=t[a],y(o,n[a])||r.invalidTypeImp(a,t[e.NAME])):r.missingPropertyImp(a,t[e.NAME]));for(a in t)a!==e.ID&&a!==e.NAME&&a!==e.DESCRIPTION&&a!==e.INHERIT&&a!==e.CLASS&&a!==e.CORE&&void 0===n[a]&&r.unknownPropertyImp(a,t[e.NAME])}function y(t,n){let a=!0;return a=v(n,"string")&&-1!==e.DEFAULT_TYPES.indexOf(n)?v(t,n):f(t,n),a}function f(e,t){let n=!0,a=s.type[t],r=0,o=0;if(v(a,"undefined"))n=!1;else if(v(e,"undefined"))n=!1;else if("array"===a.type)for(r=e.length,o=0;o<r&&(n=v(a.schema,"undefined")?w(e[o],a.type):A(e[o],a.schema),!1!==n);o++);else n=v(a.schema,"undefined")?w(e,a.type):A(e,a.schema);return n}function p(e){return e.trim()}function h(t){return v(t,"string")&&-1===e.DEFAULT_TYPES.indexOf(t)&&!j(t)}function g(e){let t="";return t=Array.isArray(e)?"array":typeof e,"any"===e&&(t="any"),t}function b(e){let t="";return t=e&&e.constructor?e.constructor.name:typeof e,t}function _(e,t){return-1!==t.indexOf(e)}function v(e,t){let n=!0,a=null;switch(t){case"array":n=Array.isArray(e);break;case"date":"string"==typeof e?(a=new Date(e),n=!isNaN(a.getDate())):n=e instanceof Date;break;case"any":n=!0;break;default:n=t===typeof e}return n}function O(t,n,a){let r=!1,o=s.generatedModels[n],i="";return o&&o[e.NAME]&&(o=s.generatedSchemas[o[e.NAME]]),o&&(i=o[t.split(".")[0]],i===a&&(r=!0)),r}function S(e,t){let n="",a=t;for(n in e)e.hasOwnProperty(n)&&0!==n.indexOf("_")&&(a[n]=e[n]);return a}function I(e,t,n){let a=null,r=[],o=[],i="";switch(!0){case"=>"===e:break;case"string"==typeof t&&"boolean"===t:a=n?{name:e,type:"boolean",mandatory:!1,default:!1}:{type:"boolean",readOnly:!1,mandatory:!1,default:!1};break;case"string"==typeof t&&"string"===t:a=n?{name:e,type:"string",mandatory:!1,default:""}:{type:"string",readOnly:!1,mandatory:!1,default:""};break;case"string"==typeof t&&"number"===t:a=n?{name:e,type:"number",mandatory:!1,default:0}:{type:"number",readOnly:!1,mandatory:!1,default:0};break;case"string"==typeof t&&"object"===t:a=n?{name:e,type:"object",mandatory:!1,default:{}}:{type:"object",readOnly:!1,mandatory:!1,default:{}};break;case"string"==typeof t&&"array"===t:a=n?{name:e,type:"array",mandatory:!1,default:[]}:{type:"array",readOnly:!1,mandatory:!1,default:[]};break;case"string"==typeof t&&"date"===t:a=n?{name:e,type:"date",mandatory:!1,default:"1970-01-01T00:00:00.000Z"}:{type:"date",readOnly:!1,mandatory:!1,default:"1970-01-01T00:00:00.000Z"};break;case"string"==typeof t&&"any"===t:a=n?{name:e,type:"any",mandatory:!1,default:null}:{type:"any",readOnly:!1,mandatory:!1,default:""};break;case"string"==typeof t:i={},r=Ee.collections._Type.find({name:t}),r.length&&r[0].value&&(i=r[0].value[0]),o=Ee.collections._Schema.find({_name:t}),o.length&&(i=""),a=n?{name:e,type:t,mandatory:!1,default:i}:{type:t,readOnly:!1,mandatory:!1,default:i};break;case Array.isArray(t)&&"boolean"===t[0]:a=n?{name:e,type:["boolean"],mandatory:!1,default:[]}:{type:["boolean"],readOnly:!1,mandatory:!1,default:[]};break;case Array.isArray(t)&&"string"===t[0]:a=n?{name:e,type:["string"],mandatory:!1,default:""}:{type:["string"],readOnly:!1,mandatory:!1,default:""};break;case Array.isArray(t)&&"number"===t[0]:a=n?{name:e,type:["number"],mandatory:!1,default:[]}:{type:["number"],readOnly:!1,mandatory:!1,default:[]};break;case Array.isArray(t)&&"object"===t[0]:a=n?{name:e,type:["object"],mandatory:!1,default:[]}:{type:["object"],readOnly:!1,mandatory:!1,default:[]};break;case Array.isArray(t)&&"date"===t[0]:a=n?{name:e,type:["date"],mandatory:!1,default:[]}:{type:["date"],readOnly:!1,mandatory:!1,default:[]};break;case Array.isArray(t)&&"any"===t[0]:a=n?{name:e,type:["any"],mandatory:!1,default:[]}:{type:["any"],readOnly:!1,mandatory:!1,default:[]};break;case Array.isArray(t):a=n?{name:e,type:t,mandatory:!1,default:[]}:{type:t,readOnly:!1,mandatory:!1,default:[]}}return a}function N(e){let t="",n="",a={};for(t in e=JSON.parse(JSON.stringify(e)))if(e.hasOwnProperty(t)&&0!==t.indexOf("_"))switch(!0){case"string"==typeof e[t]||Array.isArray(e[t]):e[t]=I(t,e[t],!1);break;case"object"==typeof e[t]&&void 0===e[t]["=>"]:e[t]=S(e[t],I(t,e[t].type||"any"));break;case"object"==typeof e[t]&&void 0!==e[t]["=>"]:for(n in a={params:[],result:"any"},e[t])"string"==typeof e[t][n]&&("=>"===n?a.result=e[t][n]:a.params.push(I(n,e[t][n],!0))),"object"==typeof e[t][n]&&a.params.push(S(e[t][n]),I(n,e[t][n].type||"any"));e[t]=a}return e}function k(){s={inheritance:{},inheritanceTree:{},schemas:{},generatedSchemas:{},models:{},generatedModels:{},states:{},type:{}}}function w(e,t,n){let a=!0;switch(!0){case h(t):a=f(e,t),a||(s.type[t]?r.invalidEnumType(e,t,s.type[t].type):r.invalidEnumType(e,t)),a&&(a=function(e,t){let n=s.type[t],a=!0;return Array.isArray(n.value)&&-1===n.value.indexOf(e)&&(a=!1),!1===a&&r.invalidEnumValue(e,t),a}(e,t));break;case j(t):n||(null!==e&&"string"!=typeof e?a=D(b(e),t):null!==e&&(a=!1));break;default:a=function(e,t,n){let a=!0,r="",o=0,i=0;switch(r=g(t),r){case"string":a=v(e,t);break;case"array":if(Array.isArray(e))for(i=e.length,o=0;o<i;o++)switch(!0){case h(t[0]):a=f(e[o],t[0]);break;case j(t[0]):n?a=!1:""!==e[o]&&null!==e[o]&&"string"!=typeof e[o]&&(a=D(b(e[o]),t[0]));break;default:a=v(e[o],t[0])}else a=!1}return a}(e,t,n)}return a}function E(e,t){let n=!0;return j(t.type)?(n=function(e,t){let n=!1,a="";return a=e.constructor.name,"Function"===a&&(a=e.name),n=a===t,n}(fe.get(e),p(t.type))&&-1!==t.value.indexOf(e),n||r.invalidEnumValue(e,t.type)):(n=v(e,t.type)&&-1!==t.value.indexOf(e),n||r.invalidEnumValue(e,t.name)),n}function A(e,t){let n="",a=null,o=!0,i=!0,l="",c="",d="",u=0,m=0;function y(){let t=!0,o=[];return c=b(l),c=e[c],h(c)?s.type[c]?s.type[c].schema?t=A(a,s.type[c].schema):(t=v(a,s.type[c].type),o=s.type[c].value,o&&(t=_(a,o))):t=!1:t="array"===c?Array.isArray(a):j(c)?v(a,"object")||v(a,"string"):v(a,c),t||r.invalidPropertyType(n,c,a),t}function f(){let t=!0,o=[];switch(c=l.replace("{","").replace("}","").trim(),c=e[c],!0){case"string"==typeof c:h(c)?s.type[c]?s.type[c].schema?t=A(a,s.type[c].schema):(t=v(a,s.type[c].type),o=s.type[c].value,o&&(t=_(a,o))):t=!1:t="array"===c?Array.isArray(a):j(c)?v(a,"object")||v(a,"string"):v(a,c);break;case Array.isArray(c):Array.isArray(a)||(t=!1);break;default:t=!1}return t||r.invalidPropertyType(n,c,a),t}function p(){let e=!0;switch(d=g(l),d){case"string":if(h(d))e=A(a,l);else if(!v(a,l)){r.invalidPropertyType(n,l,a),e=!1;break}break;case"array":if(Array.isArray(a)){for(u=a.length,m=0;m<u;m++)if(h(l[0]))e=A(a[m],s.type[l[0]].schema);else if(!v(a[m],l[0])){r.invalidPropertyType(n,l[0],a[m]),e=!1;break}}else e=!1}return e}if(v(e,"object")){for(n in e){if(a=e[n],v(t[n],"undefined"))return r.unknownProperty(n,t),!1;switch(l=t[n].type,!0){case j(l):o=o&&y();break;case-1!==l.indexOf("{"):o=o&&f();break;default:o=o&&p()}if(!o)break}for(n in t)if(a=t[n],i=a.mandatory,!0===i&&v(e[n],"undefined")&&void 0!==e[n]){r.missingProperty(n),o=!1;break}}else o=!1,r.invalidPropertyFormat(e);return o}function x(t,n,a,o){let i="",l=null,c=!0,d=!0,u="",m="",y="",f=0,_=0;function O(e,t){let n=!0,r="";if(r=s.type[t],r)switch(!0){case!v(r.schema,"undefined"):n=x(e,r.schema,a,o);break;case!v(r.value,"undefined"):n=E(e,r);break;default:n=w(e,r.type)}else n=!1;return n}function S(e,n){let a=!0,s=null,l=!1;if(m=p(n),e&&e.id?(s=e,l=!0):s=fe.get(e),v(s,"undefined"))switch(!0){case v(e,"object")&&null!==e&&Object.keys(e).length>0:case v(e,"string")&&""!==e:}else D(s.constructor.name,m)?l&&o&&(t[i]=s.id()):(a=!1,r.invalidType(i,e,m));return a}function I(e,t){let n=!0,s=null,l="";switch(y=g(t),y){case"any":break;case"string":if(h(y))n=x(e,t,a,o);else if("array"===t){if("array"!==g(e)){r.invalidPropertyType(i,t,e),n=!1;break}}else if("date"===t){if(s=new Date(e),n=!isNaN(s.getDate()),!n){r.invalidPropertyType(i,t,e);break}}else if(g(e)!==t&&"any"!==g(e)){r.invalidPropertyType(i,t,e),n=!1;break}break;case"array":if(Array.isArray(e)){for(f=e.length,l=t[0],_=0;_<f;_++)if(h(l))n=O(e[_],l);else if(j(l))if("string"===g(e[_]))if(fe.get(e[_])){if(!D(b(fe.get(e[_])),p(l))){r.invalidClassName(JSON.stringify(e[_]),p(l),b(fe.get(e[_]))),n=!1;break}}else e[_];else{if(!D(b(e[_]),p(l))){r.invalidClassName(JSON.stringify(e[_]),p(l),b(e[_])),n=!1;break}o&&(e[_]=e[_].id())}else if(g(e[_])!==l&&"any"!==l){r.invalidPropertyType(i,l,e[_]),n=!1;break}}else n=!1,r.invalidType(i,e,"array");break;default:n=!1,r.unknownType(e)}return n}for(i in v(a,"undefined")&&(a=!0),v(o,"undefined")&&(o=!1),v(t,"object")||(c=!1,r.invalidConfiguration(t,"object")),t)if(l=t[i],v(n[i],"undefined")&&i!==e.CORE&&i!==e.ID){if(a)return r.unknownProperty(i,n),!1}else{switch(!0){case i===e.CORE:u="boolean";break;case i===e.ID:u="string";break;default:u=n[i].type}switch(!0){case h(u):c=c&&O(l,u);break;case j(u):c=c&&S(l,u);break;default:c=c&&I(l,u)}}for(i in n)l=n[i],d=l.mandatory,t&&v(t[i],"undefined")&&!0===d&&(r.missingProperty(i),c=!1);return c}function M(e){let t=null;return s.generatedModels[e]&&(t=s.generatedModels[e]),t}function C(e){let t=null;return s.type[e]&&s.type[e]&&(t=JSON.parse(JSON.stringify(s.type[e]))),t}function P(e,t){let n=null,a=[],o="",i=0,s=0,l="";for(a=t.split("."),s=a.length,i=0;i<s;i++)if(o=a[i],o=o.split("[")[0],0===i)n=M(e)[o].type;else if(Array.isArray(n)&&(n=n[0]),h(n))switch(l=C(n),!0){case void 0!==l.schema:l.schema[o]?n=l.schema[o].type:r.unknownPath(t,o);break;case void 0!==l.type:n=l.type;break;default:r.invalidState(e,t)}return n}function T(e,t){let n=!0,a=null,r=[],o="",i=0,s=0,l="";for(r=t.split("."),s=r.length,i=0;i<s;i++)o=r[i],o=o.split("[")[0],0===i?(a=M(e)[o].type,a||(n=!1)):(Array.isArray(n)&&(a=a[0]),h(a)&&(l=C(a),l.schema&&l.schema[o]&&(a=l.schema[o].type,a||(n=!1))));return n}function R(e){let t=[];return t=s.inheritanceTree[e]?s.inheritanceTree[e].slice():[],t}function D(e,t){let n=!1,a=[],r=0,o=0;function i(e,t){let n=!1,a=[],r=0;if(a=R(e),0!==a.length)if(-1!==a.indexOf(t))n=!0;else for(r=0;r<0&&(n=i(a[r],t),!n);r++);return n}if(e!==t){if(a=R(e),o=a.length,0!==a.length)if(-1!==a.indexOf(t))n=!0;else for(r=0;r<o&&(n=i(a[r],t),!n);r++);}else n=!0;return n}function j(e){let t=v(e,"string");return t&&(t=Object.keys(s.generatedModels).length>0&&void 0!==s.generatedModels[e]),t}var J={schema:function(t,n){let a=null,o=[],s="",l={},c=[];return void 0===n||0===Object.keys(n).length?"string"==typeof t?((n={})[e.NAME]=t,s=t):s=(n=JSON.parse(JSON.stringify(t)))[e.NAME]:((n=JSON.parse(JSON.stringify(n)))[e.NAME]=t,s=n[e.NAME]),void 0===n[e.ID]&&(n[e.ID]=i.generateId()),void 0===n[e.INHERIT]&&(n[e.INHERIT]=["_Component"]),n[e.INHERIT]=function(e){let t=[],n={};return e.forEach((function(e){let a=e.trim();void 0===n[a]&&(n[a]=a,t.push(a))})),t}(n[e.INHERIT]),x(n,e.SCHEMA_DEFINITION,!1)?(c=Ee.collections._Schema.find({_name:s}),c.length?(l=S(n,c[0]),Ee.collections._Schema.update({_name:s},l),a=c[0][e.ID]):(o=Ee.collections._Schema.insert(n),a=o[0])):r.invalidSchema(n[e.NAME]),a},model:function(t,n){let a=null,o=[],s="",l={},c=[];return void 0===n||0===Object.keys(n).length?s=(n=JSON.parse(JSON.stringify(t)))[e.NAME]:((n=JSON.parse(JSON.stringify(n)))[e.NAME]=t,s=(n=N(n))[e.NAME]),void 0===n[e.ID]&&(n[e.ID]=i.generateId()),x(n,e.MODEL_DEFINITION,!1)?(c=Ee.collections._Model.find({_name:s}),c.length?(l=S(n,c[0]),Ee.collections._Model.update({_name:s},l),a=c[0][e.ID]):(o=Ee.collections._Model.insert(n),a=o[0])):r.invalidModel(n[e.NAME]),a},type:function(t,n){let a=null,o=[],s="",l={};return void 0===n||0===Object.keys(n).length?(l=JSON.parse(JSON.stringify(t)),s=l.name):Array.isArray(n)?(n=JSON.parse(JSON.stringify(n)),l.value=n,l.name=t,l.type=typeof n[0]||"any",s=l.name):(n=JSON.parse(JSON.stringify(n)),l.schema=N(n),l.name=t,l.type="object",s=l.name),void 0===l[e.ID]&&(l[e.ID]=i.generateId()),x(l,e.TYPE_DEFINITION)?(o=Ee.collections._Type.insert(l),a=o[0]):r.invalidTypeDefinition(s),a},init:function(){k(),Ee.collection("_Logger"),Ee.collection("_Schema"),Ee.collection("_GeneratedSchema"),Ee.collection("_Model"),Ee.collection("_GeneratedModel"),Ee.collection("_Behavior"),Ee.collection("_Type"),Ee.collection("_Message"),Ee.collection("_Channel"),Ee.collection("_History")},clear:k,create:function(){!function(){let t=[],n=[],a=null,o={},i=[],l=null,c="",d="",u=0,m=0;for(s.inheritance={},s.inheritanceTree={},s.schemas={},s.generatedSchemas={},s.models={},s.generatedModels={},s.states={},s.type={},t=Ee.collections._Schema.find({}),m=t.length,u=0;u<m;u++)a=t[u],c=a[e.NAME],d=a[e.INHERIT],s.schemas[c]=a,d&&(s.inheritance[c]=d),a[e.CORE]||r.loadSchema(c);for(i=Ee.collections._Model.find({}),m=i.length,u=0;u<m;u++)o=i[u],c=o[e.NAME],s.models[c]=o,o[e.CORE]||r.loadModel(c);for(n=Ee.collections._Type.find({}),m=n.length,u=0;u<m;u++)l=n[u],s.type[l.name]=l,l.core||r.loadType(l.name)}(),d(),function(){let t="";for(t in s.schemas)s.schemas[t][e.CORE]||r.generatingSchema(t),s.generatedSchemas[t]=u(t)}(),c(),function(){let t="",n=null,a="";for(t in s.generatedModels)n=s.generatedModels[t],n&&(a=s.generatedSchemas[t],a?(n[e.CORE]||r.checkModel(t),m(n,a)):r.missingImplementation(t))}(),function(){let t="",n=null,a="",r=[],o="";for(t in s.generatedSchemas){if(r=[],n=s.generatedSchemas[t],n)for(o in n)a=n[o],0!==o.indexOf("_")&&-1!==e.INTERNAL_TYPES.indexOf(a)&&r.push(o);s.states[t]=r}}(),function(){let t="",n={};for(t in s.generatedModels)n=s.generatedModels[t],void 0===Ee.collections[n[e.NAME]]&&!1!==n[e.CLASS]&&Ee.collection(n[e.NAME])}(),function(){let t="",n={};for(t in s.generatedModels)n=s.generatedModels[t],!1!==n[e.CLASS]&&(fe.create({model:t}),n[e.CORE]||r.createClass(t))}()},isEvent:function(t,n){return O(t,n,e.EVENT_TYPE)},isProperty:function(t,n){return O(t,n,e.PROPERTY_TYPE)},isLink:function(t,n){return O(t,n,e.LINK_TYPE)},isCollection:function(t,n){return O(t,n,e.COLLECTION_TYPE)},isMethod:function(t,n){return O(t,n,e.METHOD_TYPE)},isStructure:function(e,t){let n=!1,a=null,r="";return r=P(t,e),a=Array.isArray(a)?C(r[0]):C(r),a&&a.schema&&(n=!0),n},isValidState:function(t,n){let a=!1,r=s.generatedModels[n],o={};return-1!==t.indexOf(".")?a=T(n,t):(r&&r[e.NAME]&&(r=s.generatedModels[r[e.NAME]]),o=s.states[r[e.NAME]],Array.isArray(o)&&(a=-1!==o.indexOf(t))),a},isValidType:w,isValidEnum:E,isValidSchema:A,isValidObject:x,prepareObject:function(e,t){let n="",a=null,r=!0,o="";for(n in t=JSON.parse(JSON.stringify(t)))a=t[n],r=a.mandatory,o=a.default,v(e[n],"undefined")&&(!1!==r||v(o,"undefined")||(e[n]=o))},getSchema:function(e){let t=null;return s.generatedSchemas[e]&&(t=s.generatedSchemas[e]),t},getModel:M,getType:C,getModelPathType:P,isValidModelPath:T,getParents:R,inheritFrom:D,isClassName:j};let $={};function L(e,t,n){let a=-1,r="",o=[],i=[],s="",l="",c=null,d=!0,u=!1,m=!1,y=e;return-1!==y.indexOf(".")&&(y=e.split(".")[e.split(".").length-1]),0===t.trim().indexOf("async")&&(u=!0,t=t.replace("async","")),0===t.trim().indexOf("function")&&(d=!1),d?(a=t.indexOf("=>"),l=t.substring(0,a),l=l.replace("=>",""),r=-1!==l.indexOf("(")?l.split("(")[1].replace(")","").trim():l.trim(),o=r.split(","),o.forEach((function(e){i.push(e.trim())})),s=t.substring(a+2,t.length).trim(),0===s.indexOf("{")&&(s=s.substring(1,s.lastIndexOf("}")).trim()),-1===s.indexOf("\n")&&(m=!0),d&&m&&-1===s.indexOf("return ")&&(s="return "+s)):(a=t.indexOf("{"),l=t.substring(0,a),r=l.split("(")[1].replace(")","").trim(),o=r.split(","),o.forEach((function(e){i.push(e.trim())})),s=t.substring(a+1),s=s.substring(0,s.lastIndexOf("}")).trim()),s=s.replace(/_this/g,"this"),""===i[0]&&(i=[]),n&&(i.push("$component"),i.push("$db"),i.push("$metamodel"),i.push("$workflow"),i.push("$behavior"),i.push("$state"),i.push("$log"),i.push("$helper"),i.push("$history")),c=u?""!==i[0]?new Function("__action","return function "+y+" ("+i.join(", ")+") { const AsyncFunction = async function () {}.constructor; return new AsyncFunction('"+i.join("', '")+"', __action).apply(this, arguments) };")(s):new Function("__action","return function "+y+" () { const AsyncFunction = async function () {}.constructor; return new AsyncFunction(__action).apply(this, arguments) };")(s):""!==i[0]?new Function("__action","return function "+y+" ("+i.join(", ")+") { return new Function('"+i.join("', '")+"', __action).apply(this, arguments) };")(s):new Function("__action","return function "+y+" () { return new Function(__action).apply(this, arguments) };")(s),c}var F={add:function(e,t,n,a,r,o){let s=i.generateId(),l=n.toString();return void 0===r&&(r=!1),void 0===a&&(a=!1),n=L(t,l,a),$[s]=n,Ee.collections._Behavior.insert({_id:s,component:e,state:t,action:l,useCoreAPI:a,core:r,context:o}),s},remove:function(e){let t=[];(e=e||{}).behaviorId=e.behaviorId||"",e.componentId=e.componentId||"",e.state=e.state||"",e.componentId&&(e.behaviorId?(Ee.collections._Behavior.remove({_id:e.behaviorId,component:e.componentId,state:e.state}),delete $[e.behaviorId]):(t=e.state?Ee.collections._Behavior.remove({component:e.componentId,state:e.state}):Ee.collections._Behavior.remove({component:e.componentId}),t.forEach((function(e){delete $[e]}))))},removeFromMemory:function(e){delete $[e]},getActions:function(t,n){let a=[],r=[],o=null;return r=Ee.collections._Behavior.find({component:t,state:n}),r.forEach((function(t){o=$[t[e.ID]],void 0===o&&(o=L(t.state,t.action,t.useCoreAPI),$[t[e.ID]]=o),a.push({useCoreAPI:t.useCoreAPI,context:t.context,action:o})})),a},clear:function(){$={}},get:function(e){return $[e]}};let q={};var V={set:function(e,t,n){q[e]={state:t,value:n}},get:function(e){return q[e]},clear:function(){q={}}};let H=[],G=-1,Y=!1;var U={isEnabled:function(){return Y},start:function(){Y=!0},stop:function(){Y=!1},pushState:function(e){H.push(e)},state:function e(){return e[e.length-1]},back:function(){let e=H[G],t={};if(e){switch(e.action){case"insert":Ee.collections[e.collection].remove({_id:e.id}),r.historyDocumentRemoved(e.id,e.collection);break;case"remove":Ee.collections[e.collection].insert(JSON.parse(e.oldValue)),r.historyDocumentInserted(e.id,e.collection,e.oldValue);break;case"update":t[e.field]=JSON.parse(e.oldValue),Ee.collections[e.collection].update({_id:e.id},t),r.historyDocumentUpdated(e.id,e.collection,e.field,e.oldValue)}G-=1}return G},forward:function(){G+=1;let e=H[G],t={};if(e)switch(e.action){case"insert":Ee.collections[e.collection].insert(JSON.parse(e.value)),r.historyDocumentInserted(e.id,e.collection,e.value);break;case"remove":Ee.collections[e.collection].remove({_id:e.id}),r.historyDocumentRemoved(e.id,e.collection);break;case"update":t[e.field]=JSON.parse(e.value),Ee.collections[e.collection].update({_id:e.id},t),r.historyDocumentUpdated(e.id,e.collection,e.field,e.value)}return G},get:function(e){let t=null;return t=e<0?H[H.length+e]:H[e],t},from:function(e){G=-1===e?H.length-1:e},dump:function(){return JSON.stringify({stack:H})},load:function(e){let t=!0;try{let n={},a={};n="string"==typeof e?JSON.parse(e).stack:e.stack,n.forEach((function(e){if(e)switch(e.action){case"insert":Ee.collections[e.collection]?(Ee.collections[e.collection].insert(JSON.parse(e.value)),r.historyDocumentInserted(e.id,e.collection,e.value)):t=!1;break;case"remove":Ee.collections[e.collection]?(Ee.collections[e.collection].remove({_id:e.id}),r.historyDocumentRemoved(e.id,e.collection)):t=!1;break;case"update":Ee.collections[e.collection]?(a[e.field]=JSON.parse(e.value),Ee.collections[e.collection].update({_id:e.id},a),r.historyDocumentUpdated(e.id,e.collection,e.field,e.value)):t=!1}}))}catch(e){t=!1}return t},clear:function(){H=[]}};function B(e){this.message=e,this.name="RuntimeError"}function z(e){return-1!==e.indexOf(".")}function K(e,t){let n=null,a=[],o=[],i=0,s=0,l=0,c=0;if(J.getModel(e)?n=J.getModel(e)[t]:r.unknownModel(e),n){if(a=n.params,a)for(i=a.length,s=0;s<i;s++)void 0!==a[s].mandatory&&!0!==a[s].mandatory||(l+=1),c+=1;o.push(l),o.push(c)}else-1===t.indexOf("[")&&-1===t.indexOf(".")&&r.unknownMethod(e,t);return o}function Z(e,t,n){let a=F.getActions(e.id(),t),o=[],i=0,s=0,l=null;if(!a.length||n)if("Function"!==e.constructor.name)a=a.concat(Z(fe.get(e.constructor.name),t,n));else for(o=J.getParents(e.name),i=o.length,s=0;s<i&&(l=fe.get(o[s]),l?a=a.concat(Z(l,t,n)):r.unknownComponent(o[s],e.name),!a.length);s++);return a.length&&a.reverse(),a}function X(e,t,n,a,o){let s=null,l=[],c="",d=0,u=0;c="Function"===e.constructor.name?e.name:e.constructor.name,J.isProperty(t,c)||J.isLink(t,c)||J.isCollection(t,c)||(a=function(e,t,n){let a=null,o=[],i=[],s=0,l=0;if(a=J.getModel(e)[t],a){if(o=a.params,o)for(s=o.length,l=0;l<s;l++)!1===o[l].mandatory&&void 0===n[l]?i.push(o[l].default):i.push(n[l])}else-1===t.indexOf("[")?r.unknownMethod(e,t):i=n;return i}(c,t,a));try{for(u=a.length,d=0;d<u;d++)l.push(a[d]);n.useCoreAPI&&(l.push(fe),l.push(Ee),l.push(J),l.push({checkInputNumbers:Q,checkInput:W,checkOutput:ee,process:te}),l.push(F),l.push(V),l.push(r),l.push(i),l.push(U)),o?n.context?setTimeout(n.action.bind.apply(n.action,[n.context].concat(l)),0):setTimeout(n.action.bind.apply(n.action,[e].concat(l)),0):s=n.context?n.action.apply(n.context,l):n.action.apply(e,l)}catch(n){if(n instanceof B)throw n;e&&e.error&&e.error({message:"error when running the behavior '"+t+"' on component '"+e.id()+"'",stack:n}),i.getRuntime()&&(e&&i.getRuntime().system()&&i.getRuntime().system().id&&e.id()!==i.getRuntime().system().id()&&i.getRuntime().system().error({message:"error when running the behavior '"+t+"' on component '"+e.id()+"'",stack:n}),i.getRuntime().error({message:"error when running the behavior '"+t+"' on component '"+e.id()+"'",stack:n})),r.actionInvokeError(t,e.id(),e.constructor.name,n.message)}return s}function Q(e,t,n){let a="",r=-1,o="",i="",s=[],l=0,c=[],d=!1,u=!1,m=!1,y=!1,f=!0;switch(a=n.toString(),0===a.trim().indexOf("async")&&(a=a.replace("async","")),0===a.trim().indexOf("function")&&(f=!1),r=f?a.indexOf("=>"):a.indexOf("{"),o=a.substring(0,r),o=o.replace("=>",""),i=-1!==o.indexOf("(")?o.split("(")[1].replace(")","").trim():o.trim(),s=i.split(","),""===s[0]&&(s=[]),l=s.length,d=J.isProperty(t,e),u=J.isLink(t,e),m=J.isCollection(t,e),!0){case m:c=[2,2];break;case d:c="array"===J.getModelPathType(e,t)?[2,2]:[1,1];break;case u:c=[1,1];break;default:c=K(e,t)}return c[0]<=l&&l<=c[1]&&(y=!0),y}function W(e){let t=(e=e||{}).component||null,n=e.methodName||"",a=e.args||"",o=[],i=[],s=[],l="",c=a.length,d=0,u=null,m=!0,y=!1,f=!1,p=!1;switch(l="Function"===t.constructor.name?t.name:t.constructor.name,y=J.isProperty(n,l),f=J.isLink(n,l),p=J.isCollection(n,l),o=function(e,t){let n=null,a=[],o=[],i=0,s=0;if(J.getModel(e)?n=J.getModel(e)[t]:r.unknownModel(e),n){if(a=n.params,a)for(i=a.length,s=0;s<i;s++)o.push(a[s].name)}else z(t)||r.unknownMethod(e,t);return o}(l,n),!0){case p&&-1===n.indexOf("."):i=a&&a[1]&&"reset"===a[1]?[[J.getModel(l)[n].type[0]],"string"]:[J.getModel(l)[n].type[0],"string"],s=[2,2];break;case y&&-1===n.indexOf("."):i=z(n)?[J.getModelPathType(l,n)]:[J.getModel(l)[n].type],"array"===J.getModelPathType(l,n)?(i=a&&a[1]&&"reset"===a[1]?[["any"],"string"]:["any","string"],s=[2,2]):s=[1,1];break;case f&&-1===n.indexOf("."):i=[J.getModel(l)[n].type],s=[1,1];break;default:i=function(e,t){let n=null,a=[],o=[],i=0,s=0;if(J.getModel(e)?n=J.getModel(e)[t]:r.unknownModel(e),n){if(a=n.params,a)for(i=a.length,s=0;s<i;s++)o.push(a[s].type)}else-1===t.indexOf("[")&&-1===t.indexOf(".")&&r.unknownMethod(e,t);return o}(l,n),s=K(l,n)}for(void 0===c&&(c=1),(c<s[0]||s[1]<c)&&(m=!1,r.invalidParamNumber(t.id(),t.constructor.name,n)),d=0;d<c;d++)if(u=a[d],void 0===u){if(!(d<s[0]))continue;m=!1,r.invalidParamNumber(t.id(),t.constructor.name,n)}else J.isValidType(u,i[d])||(m=!1,r.invalidParamType(t.id(),t.constructor.name,n,o[d]));return m}function ee(e){let t=(e=e||{}).component||null,n=e.methodName||"",a=null,o="",i=null,s=!0;return a=void 0!==e.methodResult?e.methodResult:void 0,o="Function"===t.constructor.name?t.name:t.constructor.name,i=function(e,t){let n=null,a=null;return J.getModel(e)?n=J.getModel(e)[t].result:r.unknownModel(e),n&&(a=n),a}(o,n),J.isValidType(a,i)||(s=!1,r.invalidResultType(t.id(),t.constructor.name,n,"string"==typeof i?i:JSON.stringify(i),Array.isArray(a)?"array":typeof a)),s}function te(e){(e=e||{}).id=e.id||"",e.component=e.component||"",e.state=e.state||"",e.data=e.data||[],e.context=e.context||null;let t,n=null,a="",o=[],i=0,s=0,l=!1,c=!1,d=!1,u=!1,m=!1,y=!1,f=[],p=null,h=null;if(a=V.get(e.component),a&&"destroy"===a.state&&r.invalidUseOfComponent(e.component),e.id?(f=Ee.collections._Behavior.find({_id:e.id}),0===f.length&&(p=f[0],n=fe.get(p.component),n&&(l="Function"===n.constructor.name?n.name:n.constructor.name,c=J.isProperty(p.state,l),d=J.isLink(p.state,l),u=J.isCollection(p.state,l),m=J.isEvent(p.state,l),y=J.isMethod(p.state,l),h=F.get(e.id),h&&o.push({useCoreAPI:p.useCoreAPI,context:p.context,action:h})))):(n=fe.get(e.component),n&&(l="Function"===n.constructor.name?n.name:n.constructor.name,c=J.isProperty(e.state,l),d=J.isLink(e.state,l),u=J.isCollection(e.state,l),m=J.isEvent(e.state,l),y=J.isMethod(e.state,l),o=Z(n,e.state,m))),o.length){if(W({component:n,methodName:e.state,args:e.data}))if(y)t=X(e.context||n,e.state,o[0],e.data,!1),ee({component:n,methodName:e.state,methodResult:t});else{for(s=o.length,i=0;i<s;i++)X(e.context||n,e.state,o[i],e.data,!0);V.set(n.id(),e.state,e.data)}}else n&&(m||c||d||u)&&V.set(n.id(),e.state,e.data);return t}B.prototype=new Error,B.prototype.constructor=B;var ne={checkInputNumbers:Q,checkInput:W,checkOutput:ee,process:te};let ae={};function re(e){let t=[],n=[],a="",o="",s="",l="",c=!1,d=!1;function u(){let e=0,a=0,r=t.length;for(n.forEach((function(n){t[e]=d?i.getRuntime().require(n):n,e+=1})),a=e;a<r;a++)delete t[a];t.length=n.length}function m(e,t,u,m){let y=0,f=0,p=[],h=null;if(U.isEnabled()&&(h=JSON.stringify(n)),c)r.readOnlyProperty(o,s,l);else if(d)if(e&&J.inheritFrom(e.constructor.name,a)){switch(!0){case"push"===t:n.push(e.id());break;case"unshift"===t:n.unshift(e.id());break;case"splice"===t:for(p=n.splice(u,m,e),f=p.length,y=0;y<f;y++)ne.process({component:o,state:l,data:[ae[p[y]],"remove"]})}U.isEnabled()&&0!==s.indexOf("_")&&U.pushState({action:"update",collection:s,id:o,field:l,value:JSON.stringify(n),oldValue:h}),i.isRuntime()&&i.getRuntime().require("db").update({collection:s,id:o,field:l,value:n}),ne.process({component:o,state:l,data:[e,"add"]})}else r.invalidPropertyName(o,s,l,e,a);else if(e&&J.isValidType(e,a)){switch(!0){case"push"===t:n.push(e);break;case"unshift"===t:n.unshift(e);break;case"splice"===t:n.splice(u,m,e)}U.isEnabled()&&0!==s.indexOf("_")&&U.pushState({action:"update",collection:s,id:o,field:l,value:JSON.stringify(n),oldValue:h}),i.isRuntime()&&i.getRuntime().require("db").update({collection:s,id:o,field:l,value:n}),ne.process({component:o,state:l,data:[e,"add"]})}else r.invalidPropertyName(o,s,l,e,a);return n.length}function y(e){let t,a=null,u=null;if(U.isEnabled()&&(u=JSON.stringify(n)),c)r.readOnlyProperty(o,s,l);else if(0!==n.length){switch(!0){case"pop"===e:a=n.pop();break;case"shift"===e:a=n.shift()}U.isEnabled()&&0!==s.indexOf("_")&&U.pushState({action:"update",collection:s,id:o,field:l,value:JSON.stringify(n),oldValue:u}),i.isRuntime()&&i.getRuntime().require("db").update({collection:s,id:o,field:l,value:n}),t=d?ae[a]:a,ne.process({component:o,state:l,data:[t,"remove"]})}return t}return a=(e=e||{}).type||"",o=e.id||"",l=e.propertyName||"",n=e.arr||[],s=e.classId||"",void 0!==e.readOnly&&(c=e.readOnly),d=J.isClassName(a),n.forEach((function(e){d?t.push(i.getRuntime().require(e)):t.push(e)})),t.push=function(e){let n=m(e,"push");return t[t.length]=e,n},t.pop=function(){let e=y("pop"),n=t.length;return 0!==n&&(delete t[n],t.length=n-1),e},t.shift=function(){let e=y("shift");return u(),e},t.unshift=function(e){let t=m(e,"unshift");return u(),t},t.concat=function(t){let a=0,r=0,o=null;if(Array.isArray(t))for(r=t.length,a=0;a<r;a++)m(t[a],"push");return e.arr=n,o=new re(e),u(),o},t.sort=function(e){let a=null;return U.isEnabled()&&(a=JSON.stringify(n)),n.sort(e),U.isEnabled()&&0!==s.indexOf("_")&&U.pushState({action:"update",collection:s,id:o,field:l,value:JSON.stringify(n),oldValue:a}),i.isRuntime()&&i.getRuntime().require("db").update({collection:s,id:o,field:l,value:n}),u(),t},t.reverse=function(){let e=null;return U.isEnabled()&&(e=JSON.stringify(n)),n.reverse(),U.isEnabled()&&0!==s.indexOf("_")&&U.pushState({action:"update",collection:s,id:o,field:l,value:JSON.stringify(n),oldValue:e}),i.isRuntime()&&i.getRuntime().require("db").update({collection:s,id:o,field:l,value:n}),u(),t},t.splice=function(e,t,a){let r=null,c=[],y=0,f=0,p=null;if(U.isEnabled()&&(r=JSON.stringify(n)),void 0!==a)m(a,"splice",e,t);else for(c=n.splice(e,t),U.isEnabled()&&0!==s.indexOf("_")&&U.pushState({action:"update",collection:s,id:o,field:l,value:JSON.stringify(n),oldValue:r}),i.isRuntime()&&i.getRuntime().require("db").update({collection:s,id:o,field:l,value:n}),f=c.length,y=0;y<f;y++)p=d?ae[c[y]]:c[y],ne.process({component:o,state:l,data:[p,"remove"]});return u(),c},t.slice=function(e,t){let a=n.slice(e,t);return u(),a},t}function oe(e,t){let n=[],a=[],r=0,o=0;if(n=J.getModel(e)[t].params,n)for(r=n.length,o=0;o<r;o++)a.push(n[o].name);return a}function ie(e,t,n){let a=null,r=Ee.store[e][t],o=n.split("."),i=o.length,s=0,l="",c=-1;for(a=r,s=0;s<i;s++)-1!==o[s].indexOf("[")?(l=o[s].split("[")[0],c=o[s].split("[")[1].replace("]",""),a=a[l][c]):a&&(a=a[o[s]]);return a}function se(e,t,n,a){let r=null,o=Ee.store[e][t],i=n.split("."),s=i.length,l=0,c="",d=-1;for(r=o,l=0;l<s-1;l++)-1!==i[l].indexOf("[")?(c=i[l].split("[")[0],d=i[l].split("[")[1].replace("]",""),r=r[c][d]):r=r[i[l]];r[i[l]]=a}function le(t,n,a){let o=function(t){let n=null,a=null,r=[],o=0,i=0,s=[];for(n=J.getModel(t),a=J.getSchema(n[e.NAME]),r=Object.keys(a),o=r.length,i=0;i<o;i++)a[r[i]]!==e.LINK_TYPE&&a[r[i]]!==e.PROPERTY_TYPE&&a[r[i]]!==e.COLLECTION_TYPE||s.push({name:r[i],type:n[r[i]].type,readOnly:n[r[i]].readOnly});return s}(t);o.forEach((function(e){let o={},s="",l="",c="";s=e.name,l=e.type,c=e.readOnly,Array.isArray(l)||"array"===l?(o=function(e,n){let o=[],d=null,u=null,m=null,y=null,f=null;if(void 0===n){if(void 0===e)return u=new re({id:this.id(),propertyName:s,readOnly:c,classId:a,type:"array"===l?"any":l[0],arr:Ee.store[a][this.id()][s]}),u;if(Array.isArray(e))!function(e,t){let n=!0;return"any"!==t&&e.forEach((function(e){J.isClassName(t)?J.isValidType(e,t)||J.inheritFrom(e.constructor.name,t)||(n=n&&!1):J.isValidType(e,t)||(n=n&&!1)})),n}(e,"array"===l?"any":l[0])?r.invalidCollectionItem(this.id(),this.constructor.name,s,e,"array"===l?"any":l[0]):(o=Ee.collections[a].find({_id:this.id()}),o.length&&(d=o[0],y=function(e,t){let n=[];return e.forEach((function(e){if(J.isClassName(t))switch(!0){case"string"==typeof e:n.push(e);break;case void 0!==e.id:n.push(e.id());break;default:n.push(null)}else n.push(e)})),n}(e,"array"===l?"any":l[0]),ne.process({component:this.id(),state:s,data:[e,"reset"]}),U.isEnabled()&&(f=JSON.stringify(d[s])),d[s]=y,U.isEnabled()&&0!==a.indexOf("_")&&U.pushState({action:"update",collection:a,id:this.id(),field:s,value:JSON.stringify(d[s]),oldValue:f}),i.isRuntime()&&i.getRuntime().require("db").update({collection:a,id:this.id(),field:s,value:d[s]})));else if("number"==typeof e){if(m=Ee.store[a][this.id()][s][e],m){switch(!0){case J.isClassName("array"===l?"array":l[0]):y=i.getRuntime().require(m);break;case"array"===l?"array":"date"===l[0]:y=new Date(m);break;case J.isStructure(s,t):y=ce("",s+"["+e+"]",t,this.id());break;default:y=m}return y}}else r.invalidPropertyName(this.id(),this.constructor.name,s,e,"number")}else if(c)r.readOnlyProperty(this.id(),this.constructor.name,s);else if(J.isValidType(n,"array"===l?"any":l[0])||J.inheritFrom(n.constructor.name,"array"===l?"array":l[0])&&J.isClassName("array"===l?"array":l[0])){if(o=Ee.collections[a].find({_id:this.id()}),o.length){switch(!0){case J.isClassName("array"===l?"array":l[0]):switch(!0){case"string"==typeof n:y=n;break;case void 0!==n.id:y=n.id();break;default:y=""}break;case!!Array.isArray(l)&&l[0]:y="string"==typeof n?n:n.toISOString();break;default:y=""}d=o[0],d[s][e]=y,U.isEnabled()&&(f=JSON.stringify(d[s])),U.isEnabled()&&0!==a.indexOf("_")&&U.pushState({action:"update",collection:a,id:this.id(),field:s,value:JSON.stringify(d[s]),oldValue:f}),i.isRuntime()&&i.getRuntime().require("db").update({collection:a,id:this.id(),field:s,value:d[s]}),ne.process({component:this.id(),state:s,data:[n,"add"]})}}else r.invalidPropertyName(this.id(),this.constructor.name,s,n,l[0])},n.prototype[s]=new Function("__proxy","return function "+s+" (position, value) { return __proxy.apply(this, arguments) };")(o)):(o=function(e){let n=[],o=null,d=null,u=null,m=null;if(void 0===e){if(o=Ee.store[a][this.id()],o){switch(!0){case J.isClassName(l):d=ye(o[s]);break;case"date"===l:d=new Date(o[s]);break;case"json"===l:d=o[s],d=JSON.parse(JSON.stringify(d));break;case"array"===l:d=new re({id:this.id(),propertyName:s,readOnly:c,classId:a,type:"any",arr:Ee.store[a][this.id()][s]});break;case J.isStructure(s,a):d=ce("",s,t,this.id());break;default:d=o[s]}return d}r.destroyedComponentCall(s,this.id())}else if(c)r.readOnlyProperty(this.id(),this.constructor.name,s);else if(J.isValidType(e,l)){if(n=Ee.collections[a].find({_id:this.id()}),n.length){switch(o=n[0],U.isEnabled()&&(u=JSON.stringify(o[s])),!0){case J.isClassName(l):m=null===e?e:e.id();break;case"date"===l:"string"==typeof e?m=e:(m=e.toISOString(),o[s]=e.toISOString());break;default:m=e}o[s]=m,U.isEnabled()&&0!==a.indexOf("_")&&U.pushState({action:"update",collection:a,id:this.id(),field:s,value:JSON.stringify(m),oldValue:u}),i.isRuntime()&&i.getRuntime().require("db")&&i.getRuntime().require("db").update({collection:a,id:this.id(),field:s,value:m}),"_Behavior"===a&&F.removeFromMemory(this.id()),ne.process({component:this.id(),state:s,data:[e]})}}else r.invalidPropertyName(this.id(),this.constructor.name,s,e,l)},n.prototype[s]=new Function("__proxy","return function "+s+" (value) { return __proxy.apply(this, arguments) };")(o))}))}function ce(e,t,n,a){let o,s=function(e,t){let n=null,a=null,r=[],o=[];return n=J.getModelPathType(t,e),a=J.getType(n),a&&a.schema&&(o=Object.keys(a.schema),o.forEach((function(e){a.schema[e].name=e,r.push(a.schema[e])}))),r}(e?e+"."+t:t,n);return ie(n,a,e?e+"."+t:t)&&(o={},s.forEach((function(s){let l={},c="",d="",u="";c=s.name,d=s.type,u=s.readOnly,Array.isArray(d)||"array"===d?(l=function(o,s){let l=[],m=null,y=null,f=null,p="",h="",g=null;if(p=e?e+"."+t:t,h=p+"."+c,void 0===s){if(void 0===o)return y=new re({id:a,propertyName:h,readOnly:u,classId:n,type:Array.isArray(d)?d[0]:"any",arr:ie(n,a,h)}),y;if(Array.isArray(o))!function(e,t){let n=!0;return e.forEach((function(e){J.isValidType(e,t)||(n=n&&!1)})),n}(o,Array.isArray(d)?d[0]:"any")?r.invalidPropertyName(a,this.constructor.name,c,o,d[0]):(l=Ee.collections[n].find({_id:a}),l.length&&(U.isEnabled()&&(g=ie(n,a,h)),se(n,a,h,o),-1!==h.indexOf("[")&&ne.process({component:a,state:h.replace(/\[(\d)*\]/g,""),data:[o,"reset"]}),ne.process({component:a,state:h,data:[o,"reset"]}),U.isEnabled()&&0!==n.indexOf("_")&&U.pushState({action:"update",collection:n,id:a,field:h,value:JSON.stringify([]),oldValue:JSON.stringify(g)}),i.isRuntime()&&i.getRuntime().require("db").update({collection:n,id:a,field:h,value:o})));else if("number"==typeof o)if(m=Ee.store[n][a],m)switch(!0){case J.isClassName(Array.isArray(d)?d[0]:"any"):return f=ye(ie(n,a,h+"["+o+"]")),f;case!!Array.isArray(d)&&d[0]:return f=new Date(ie(n,a,h+"["+o+"]")),f;case!!Array.isArray(d)&&d[0]:return f=ie(n,a,h+"["+o+"]"),f=JSON.parse(JSON.stringify(f)),f;case J.isStructure(h,n):return f=ce(p,c+"["+o+"]",n,a),f;default:return f=ie(n,a,h+"["+o+"]"),f}else r.destroyedComponentCall(h[o]+"["+o+"]",a);else r.invalidPropertyName(a,this.constructor.name,c,o,"number")}else if(u)r.readOnlyProperty(a,this.constructor.name,c);else if(J.isValidType(s,Array.isArray(d)?d[0]:"any")){if(l=Ee.collections[n].find({_id:a}),l.length){let e=ie(n,a,h);switch(void 0===e&&(e=[]),!0){case J.inheritFrom(s.constructor.name,Array.isArray(d)?d[0]:"any")&&J.isClassName(Array.isArray(d)?d[0]:"any"):e[o]=s.id();break;case!!Array.isArray(d)&&d[0]:e[o]=s.toISOString();break;default:e[o]=s}U.isEnabled()&&(g=ie(n,a,h)),se(n,a,h,e),U.isEnabled()&&0!==n.indexOf("_")&&U.pushState({action:"update",collection:n,id:a,field:h,value:JSON.stringify(s),oldValue:JSON.stringify(g)}),i.isRuntime()&&i.getRuntime().require("db").update({collection:n,id:a,field:h,value:e}),-1!==h.indexOf("[")&&ne.process({component:a,state:h.replace(/\[(\d)*\]/g,""),data:[s,"add"]}),ne.process({component:a,state:h,data:[s,"add"]})}}else r.invalidPropertyName(a,this.constructor.name,c,s,Array.isArray(d)?d[0]:"any")},o[c]=new Function("__proxy","return function "+c+" (position, value) { return __proxy.apply(this, arguments) };")(l)):(l=function(o){let l=[],m=null,y=null,f="",p="",h=null,g=null;if(f=e?e+"."+t:t,p=f+"."+c,void 0===o){if(m=Ee.store[n][a],m){switch(!0){case J.isClassName(d):y=ye(ie(n,a,p));break;case"date"===d:y=new Date(ie(n,a,p));break;case"json"===d:y=ie(n,a,p),y=JSON.parse(JSON.stringify(y));break;case J.isStructure(p,n):y=ce(f,c,n,a);break;default:y=ie(n,a,p)}return void 0===y&&void 0!==s.default&&(y=s.default),y}r.destroyedComponentCall(p,a)}else if(u)r.readOnlyProperty(a,n,p);else if(J.isValidType(o,d)){if(l=Ee.collections[n].find({_id:a}),l.length){switch(m=l[0],U.isEnabled()&&(h=ie(n,a,p)),!0){case J.isClassName(d):g=o.id();break;case"date"===d:g=o.toISOString();break;default:g=o}se(n,a,p,g),U.isEnabled()&&0!==n.indexOf("_")&&U.pushState({action:"update",collection:n,id:a,field:p,value:JSON.stringify(g),oldValue:JSON.stringify(h)}),i.isRuntime()&&i.getRuntime().require("db")&&i.getRuntime().require("db").update({collection:n,id:a,field:p,value:g}),"_Behavior"===n&&F.removeFromMemory(a),-1!==p.indexOf("[")&&ne.process({component:a,state:p.replace(/\[(\d)*\]/g,""),data:[o]}),ne.process({component:a,state:p,data:[o]})}}else r.invalidPropertyName(a,n,p,o,d)},o[c]=new Function("__proxy","return function "+c+" (value) { return __proxy.apply(this, arguments) };")(l))}))),o}function de(t,n,a){let o=function(t){let n=null,a=null,r=[],o=0,i=0,s=[];for(n=J.getModel(t),a=J.getSchema(n[e.NAME]),r=Object.keys(a),o=r.length,i=0;i<o;i++)a[r[i]]===e.METHOD_TYPE&&s.push(r[i]);return s}(t);o.forEach((function(e){let t=oe(a,e),o=t.join(", "),i="",s=function(){let t=null;return t=ne.process({component:this.id(),state:e,data:arguments}),t},l=function(){let t=null,n=Array.prototype.slice.call(arguments);return n.shift(),arguments[0]?t=ne.process({component:this.id(),state:e,data:n,context:arguments[0]}):r.unknownContext(a,e),t};o?(t.unshift("context"),i=t.join(", "),n.prototype[e]=new Function("__proxy","return function "+e+" ("+o+") { return __proxy.apply(this, arguments) };")(s),"name"!==e&&(n[e]=new Function("__proxy","return function "+e+" ("+i+") { return __proxy.apply(this, arguments) };")(l))):(n.prototype[e]=new Function("__proxy","return function "+e+" () { return __proxy.apply(this) };")(s),"name"!==e&&(n[e]=new Function("__proxy","return function "+e+" (context) { return __proxy.apply(this, arguments) };")(l)))}))}function ue(t,n,a){let r=function(t){let n=null,a=null,r=[],o=0,i=0,s=[];for(n=J.getModel(t),a=J.getSchema(n[e.NAME]),r=Object.keys(a),o=r.length,i=0;i<o;i++)a[r[i]]===e.EVENT_TYPE&&s.push(r[i]);return s}(t);r.forEach((function(t){let r=oe(a,t).join(", "),o=function(){let n=[],r="e89c617b6b15d24",o=[],i=0,s=-1,l={};if("_Channel"===a){for(n=Ee.collections._System.find({master:!0}),n.length&&(r=n[0][e.ID]),l.from=r,s=arguments.length,i=0;i<s;i++)o.push(arguments[i]);l.data=o,l.event=t,Ee.collections._Message.insert(l),ne.process({component:this.id(),state:"send",data:[{event:l.event,from:l.from,data:l.data}]})}else ne.process({component:this.id(),state:t,data:arguments})};n.prototype[t]=r?new Function("__proxy","return function "+t+" ("+r+") { return __proxy.apply(this, arguments) };")(o):new Function("__proxy","return function "+t+" () { return __proxy.apply(this) };")(o)}))}function me(t){let n={},a="";return a=void 0===(t=t||{}).model?i.generateId():t.model,n=function(t){return new Function("__proxy","return function "+t+" (config) { __proxy.apply(this, arguments) };")((function(n){let a={};"Object"!==(n=n||{}).constructor.name&&(r.invalidConctructorParameters(n,t),n={}),J.isValidObject(n,J.getModel(t),!0,!0)||r.invalidParameters(t,n),J.prepareObject(n,J.getModel(t)),void 0===n[e.ID]&&(n[e.ID]=i.generateId()),ae[n[e.ID]]=this,a=function(){return n[e.ID]},this.id=new Function("__proxy","return function id () { return __proxy.apply(this) };")(a),Ee.store[t][n[e.ID]]=n,U.isEnabled()&&0!==t.indexOf("_")&&U.pushState({action:"insert",collection:t,id:n[e.ID],value:JSON.stringify(n)}),i.isRuntime()&&i.getRuntime().require("db")&&i.getRuntime().require("db").insert({collection:t,document:n}),Object.freeze(this),this.init&&this.init(n)}))}(a),ae[a]=n,function(e,t){e.id=new Function("__proxy","return function id () { return __proxy.apply(this) };")((function(){return t}))}(n,a),le(t.model,n,a),de(t.model,n,a),ue(t.model,n,a),J.inheritFrom(a,"_Component")&&(function(e,t){e.prototype.on=new Function("__proxy","return function on (state, action, useCoreAPI, isCore) { return __proxy.apply(this, arguments) };")((function(e,n,a,o){let i="",s="",l=null;return a&&a.constructor&&"Boolean"!==a.constructor.name&&(l=a,a=!1,o=!0),ne.checkInput({component:this,methodName:"on",args:arguments})&&(J.isValidState(e,t)?J.isEvent(e,t)||J.isProperty(e,t)||J.isLink(e,t)||J.isCollection(e,t)||!(Ee.collections._Behavior.find({component:this.id(),state:e}).length>=1)?ne.checkInputNumbers(t,e,n)?(i=F.add(this.id(),e,n,a,o,l),s=V.get(this.id()),s&&s.state===e&&ne.process({id:i,data:s.value})):r.invalidParamNumberMethodOn(this.id(),this.constructor.name,e):r.behaviorNotUnique(t,e):r.invalidStateOn(t,e)),i}))}(n,a),function(e,t){e.on=new Function("__proxy","return function on (state, action, useCoreAPI, isCore) { return __proxy.apply(this, arguments) };")((function(e,n,a,o){let i="",s="",l=null;return a&&a.constructor&&"Boolean"!==a.constructor.name&&(l=a,a=!1,o=!0),ne.checkInput({component:this,methodName:"on",args:arguments})&&(J.isValidState(e,t)?J.isEvent(e,t)||J.isProperty(e,t)||J.isLink(e,t)||J.isCollection(e,t)||!(Ee.collections._Behavior.find({component:this.id(),state:e}).length>=1)?ne.checkInputNumbers(t,e,n)?(i=F.add(this.id(),e,n,a,o,l),s=V.get(this.id()),s&&s.state===e&&ne.process({id:i,data:s.value})):r.invalidParamNumberMethodOn(this.id(),this.constructor.name,e):r.behaviorNotUnique(t,e):r.invalidStateOn(t,e)),i}))}(n,a),function(e,t){e.off=new Function("__proxy","return function off (state, behaviorId) { return __proxy.apply(this, arguments) };")((function(e,n){ne.checkInput({component:this,methodName:"off",args:arguments})&&(J.isValidState(e,t)?F.remove({behaviorId:n,componentId:t,state:e}):r.invalidStateOff(t,e))}))}(n,a),function(e){e.require=new Function("__proxy","return function require (id) { return __proxy.apply(this, arguments) };")((function(e){return ye(e)}))}(n),function(e){e.init=new Function("__proxy","return function init (conf) { return __proxy.apply(this, arguments) };")((function(){}))}(n),function(e){e.destroy=new Function("__proxy","return function destroy () { return __proxy.apply(this) };")((function(){let e=this.id(),t=[],n=0,a=0;for(Ee.collections[e]&&(t=Ee.collections[e].remove()),delete ae[e],F.remove({componentId:e}),a=t.length,n=0;n<a;n++)F.remove({componentId:t[n]});ne.process({component:e,state:"destroy"})}))}(n)),Object.freeze(n),n}function ye(e){return ae[e]}re.prototype=[];var fe={get:ye,create:function(e){return me(e)},destroy:function(e){let t=ae[e],n="";t&&(delete ae[e],n=t.constructor.name,Ee.collections[n].remove({_id:e}),F.remove({componentId:e}),"_Behavior"===n&&F.removeFromMemory(e))},removeFromMemory:function(e){delete ae[e]},clear:function(){ae={}}};let pe=[],he=["_Runtime","_Schema","_GeneratedSchema","_Model","_GeneratedModel","_Behavior","_Type","_Metamodel","_Database","_System","_Message","_Channel","_Logger","_History"],ge=["_Schema","_GeneratedSchema","_Logger","_Model","_GeneratedModel","_Type","_History"];function be(){let e=[];return e.sort=function(t){let n="",a=[];return e.forEach((function(e){a.push(e)})),t instanceof Function?a.sort(t):(n=Object.keys(t)[0],a.sort((function(e,a){return e[n]<a[n]?1===t[n]?-1:1:e[n]>a[n]?1===t[n]?1:-1:0}))),a},e}function _e(e,t,n){let a=!0,r="";e:for(r in t)switch(!0){case"$eq"===r:if(t[r]instanceof RegExp){if(null===n[e].toString().match(t[r])){a=!1;break e}}else if(n[e]!==t[r]){a=!1;break e}break;case"$gt"===r:if(n[e]<=t[r]){a=!1;break e}break;case"$gte"===r:if(n[e]<t[r]){a=!1;break e}break;case"$lt"===r:if(n[e]>=t[r]){a=!1;break e}break;case"$lte"===r:if(n[e]>t[r]){a=!1;break e}break;case"$ne"===r:if(n[e]===t[r]){a=!1;break e}break;case"$in"===r:if(Array.isArray(t[r])&&-1===t[r].indexOf(n[e])){a=!1;break e}break;case"$nin"===r:if(Array.isArray(t[r])&&-1!==t[r].indexOf(n[e])){a=!1;break e}}return a}function ve(e,t){let n=!0,a=!1,r="",o=0,i=0;e:for(r in e){if(void 0===t[r]){n=!1;break}switch(!0){case e[r]instanceof RegExp:if(Array.isArray(t[r])&&!Array.isArray(e[r])){for(i=t[r].length,o=0;o<i;o++)if(null!==t[r][o].toString().match(e[r])){a=!0;break e}n=a}else if(null===t[r].toString().match(e[r])){n=!1;break e}break;case e[r]instanceof Object&&!Array.isArray(e[r]):n=_e(r,e[r],t);break;case Array.isArray(t[r])&&!Array.isArray(e[r]):if(-1===t[r].indexOf(e[r])){n=!1;break e}break;default:if(t[r]!==e[r]){n=!1;break e}}}return n}function Oe(){let t="",n="",a=[],o=null,i=null,s=null,l={};if(a=Ie._System.find({master:!0}),a.length){for(n in s=a[0],o=s[e.ID],l[e.ID]=o,l.name=s.name,l.description=s.description,l.version=s.version,l.master=!0,i=function(){let t={},n="",a="",r="",o=null,i=null,s=null,l=null,c=null,d="",u="",m=0,y=0,f="";if(t.schemas={},Ie._Schema.count())for(d in Se._Schema)Se._Schema[d][e.CORE]||(s=JSON.parse(JSON.stringify(Se._Schema[d])),t.schemas[d]=s);if(t.models={},Ie._Model.count())for(u in Se._Model)Se._Model[u][e.CORE]||(l=JSON.parse(JSON.stringify(Se._Model[u])),t.models[u]=l);if(t.types={},Ie._Type.count())for(r in Se._Type)Se._Type[r].core||(o=JSON.parse(JSON.stringify(Se._Type[r])),t.types[o.name]=o);for(a in t.behaviors={},Se._Behavior)Se._Behavior[a].core||(i=JSON.parse(JSON.stringify(Se._Behavior[a])),t.behaviors[a]=i);for(t.components={},m=pe.length,y=0;y<m;y++)if(n=pe[y],Ie[n].count()){for(f in c=JSON.parse(JSON.stringify(Se[n])),c)c[f][e.CORE]&&delete c[f];Object.keys(c).length&&(t.components[n]=c)}return t}(),i)i.hasOwnProperty(n)&&(l[n]=i[n]);t=JSON.stringify(l)}else t="{}",r.masterSystemNotFound();return t}be.prototype=[];const Se={},Ie={};let Ne=function(e){J.getSchema(e)||-1!==he.indexOf(e)?(Se[e]={},this.name=e,-1===he.indexOf(e)&&pe.push(e)):r.invalidCollectionName(e)};function ke(t){return function(t){let n="",a="",o="",i="",s="",l="",c="",d=[];if(t){for(i in t.types)J.type(t.types[i]);for(s in t.schemas)J.schema(t.schemas[s]);for(l in t.models)J.model(t.models[l]);for(c in J.create(),t.behaviors)Ie._Behavior.insert(t.behaviors[c]);for(a in r.initDb(),t.components)for(o in t.components[a])Ie[a].insert(t.components[a][o]);d=Ie._System.find({master:!0}),d.length&&(d[0][e.ID]===t[e.ID]?t.master=!0:t.master&&(d[0].master=!1)),Ie._System.insert(t),n=t[e.ID]}return n}(t)}function we(){let e=0,t=0,n="";for(e=pe.length,t=0;t<e;t++)n=pe[t],Ie[n].remove();for(e=he.length,t=0;t<e;t++)n=he[t],Ie[n].remove()}Ne.prototype.find=function(e){let t=new be,n={},a="",r={};if((e=e||null)&&Object.keys(e).length)if(Array.isArray(e))e.forEach(function(e){for(a in Se[this.name])r=Se[this.name][a],ve(e,r)&&void 0===n[a]&&(t.push(r),n[a]=!0)}.bind(this));else for(a in Se[this.name])r=Se[this.name][a],ve(e,r)&&t.push(r);else for(a in Se[this.name])r=Se[this.name][a],t.push(r);return t},Ne.prototype.insert=function(t){let n=[],a=null,o=[];return Array.isArray(t)?n=t:n.push(t),n.forEach(function(t){let n=[];switch(!0){case null===t:r.invalidDocumentOnDbInsert(t,this.name);break;case"_Schema"===this.name:case"_Logger"===this.name:case"_Model"===this.name:case"_Type"===this.name:case"_GeneratedModel"===this.name:case"_GeneratedSchema"===this.name:case J.isValidObject(t,J.getModel(this.name)):if(void 0===t[e.ID]&&(t[e.ID]=i.generateId()),J.prepareObject(t,J.getModel(this.name)),Se[this.name][t[e.ID]]=t,o.push(t[e.ID]),a=fe.get(this.name),a?new a(t):(U.isEnabled()&&0!==this.name.indexOf("_")&&U.pushState({action:"insert",collection:this.name,id:t[e.ID],value:JSON.stringify(t)}),i.isRuntime()&&i.getRuntime().require("db")&&i.getRuntime().require("db").insert({collection:this.name,document:t})),"_Message"===this.name&&i.isRuntime()){n=Ie._Channel.find({});let a=n.length;for(let r=0;r<a;r++)i.getRuntime().require(n[r][e.ID]),ne.process({component:n[r][e.ID],state:t.event,data:t.data})}break;default:r.invalidDocumentOnDbInsert(t,this.name)}}.bind(this)),o},Ne.prototype.update=function(t,n,a){let o=this.find(t),s=[],l=0,c=o.length,d="",u=J.getModel(this.name),m="",y=[];if(void 0===(a=a||{}).upsert&&(a.upsert=a.upsert||!1),n)for(0===c&&a.upsert&&(t[e.ID]&&(n[e.ID]=t[e.ID]),y=this.insert(n),1===y.length&&s.push(y[0])),l=0;l<c;l++)for(d in void 0!==n[e.ID]&&n[e.ID]!==o[l][e.ID]&&r.updateUuid(o[l][e.ID],n[e.ID],void 0!==fe.get(n[e.ID])),n)void 0!==o[l][d.split(".")[0]]&&("_Schema"!==this.name&&"_GeneratedSchema"!==this.name&&"_Model"!==this.name&&"_GeneratedModel"!==this.name?(m="",0!==d.indexOf("_")?m=-1!==d.indexOf(".")?J.getModelPathType(this.name,d):u[d].type:e.SCHEMA_DEFINITION[d]&&(m=e.SCHEMA_DEFINITION[d].type),m?J.isValidType(n[d],m,!0)?(U.isEnabled()&&0!==this.name.indexOf("_")&&U.pushState({action:"update",collection:this.name,id:o[l][e.ID],field:d,value:JSON.stringify(n[d]),oldValue:JSON.stringify(o[l][d])}),o[l][d]=n[d],s.push(o[l][e.ID]),i.isRuntime()&&i.getRuntime().require("db")&&i.getRuntime().require("db").update({collection:this.name,id:o[l][e.ID],field:d,value:n[d]}),"array"===m?ne.process({component:o[l][e.ID],state:d,data:[n[d],"reset"]}):ne.process({component:o[l][e.ID],state:d,data:[n[d]]})):r.invalidPropertyTypeOnDbUpdate(this.name,o[l][e.ID],d,n[d],m):r.unknownPropertyOnDbUpdate(this.name,d,o[l][e.ID])):(U.isEnabled()&&0!==this.name.indexOf("_")&&U.pushState({action:"update",collection:this.name,id:o[l][e.ID],field:d,value:JSON.stringify(n[d]),oldValue:JSON.stringify(o[l][d])}),o[l][d]=n[d],s.push(o[l][e.ID]),i.isRuntime()&&i.getRuntime().require("db")&&i.getRuntime().require("db").update({collection:this.name,id:o[l][e.ID],field:d,value:n[d]})));return s},Ne.prototype.remove=function(e){let t=[],n="",a=null,r={};if((e=e||null)&&Object.keys(e).length)if(Array.isArray(e))e.forEach(function(e){for(n in Se[this.name])r=Se[this.name][n],ve(e,r)&&(U.isEnabled()&&0!==this.name.indexOf("_")&&U.pushState({action:"remove",collection:this.name,id:n,oldValue:JSON.stringify(Se[this.name][n])}),delete Se[this.name][n],t.push(n),a=fe.get(n),a&&a.destroy(),i.isRuntime()&&i.getRuntime().require("db")&&i.getRuntime().require("db").remove({collection:this.name,id:n}))}.bind(this));else for(n in Se[this.name])r=Se[this.name][n],ve(e,r)&&(U.isEnabled()&&0!==this.name.indexOf("_")&&U.pushState({action:"remove",collection:this.name,id:n,oldValue:JSON.stringify(Se[this.name][n])}),delete Se[this.name][n],t.push(n),a=fe.get(n),a&&a.destroy(),i.isRuntime()&&i.getRuntime().require("db")&&i.getRuntime().require("db").remove({collection:this.name,id:n}));else for(n in Se[this.name])U.isEnabled()&&0!==this.name.indexOf("_")&&U.pushState({action:"remove",collection:this.name,id:n,oldValue:JSON.stringify(Se[this.name][n])}),delete Se[this.name][n],-1===ge.indexOf(this.name)&&(a=fe.get(n),a&&a.destroy()),i.isRuntime()&&i.getRuntime().require("db")&&i.getRuntime().require("db").remove({collection:this.name,id:n}),t.push(n);return t},Ne.prototype.count=function(){return Se[this.name]?Object.keys(Se[this.name]).length:0};var Ee={store:Se,collection:function(e){Ie[e]=new Ne(e)},collections:Ie,importSystem:ke,exportSystem:function(t){let n="";return n=t?function(t){let n={},a=[],r="",o=0,i=0,s=null,l=null,c=null,d=null,u=null,m="";if(a=Ie._System.find({master:!0}),a.length&&(r=a[0].name),n.name=t.name||"sub_"+r,n.version=t.version||"0.0.1",n.description=t.description||"",n.schemas={},t.schemas)for(a=Ie._Schema.find(t.schema),i=a.length,o=0;o<i;o++)s=a[o],s[e.CORE]||(n.schemas[s[e.ID]]=s);if(n.models={},t.models)for(a=Ie._Model.find(t.models),i=a.length,o=0;o<i;o++)c=a[o],c[e.CORE]||(n.models[c[e.ID]]=c);if(n.types={},t.types)for(a=Ie._Type.find(t.types),i=a.length,o=0;o<i;o++)l=a[o],l[e.CORE]||(n.types[l[e.ID]]=l);if(n.behaviors={},t.behaviors)for(d=Ie._Behavior.find(t.behaviors),i=a.length,o=0;o<i;o++)d=a[o],d.core||(n.behaviors[d[e.ID]]=d);if(n.components={},t.components)for(m in t.components)if(Ie[m])for(n.components[m]={},a=Ie[m].find(t.components[m]),i=a.length,o=0;o<i;o++)u=a[o],n.components[m][u[e.ID]]=u;return JSON.stringify(n)}(t):Oe(),n},clear:we,init:function(){let e="",t=null;t=Ie._System.find({_id:"e89c617b6b15d24"})[0],we(),fe.clear(),J.clear(),V.clear(),F.clear(),U.clear(),J.init(),e=ke(t),fe.get(e).start()}};let Ae="",xe="",Me=null;J.init(),Ae=Ee.importSystem({name:"system-runtime",master:!1,version:"6.0.0-beta.2",description:"System Runtime",schemas:{"1ac07185641fa9f":{_name:"_Behavior",_inherit:["_Component"],_core:!0,core:"property",component:"property",action:"property",state:"property",useCoreAPI:"property",context:"property",_id:"1ac07185641fa9f"},"104ad1f48518376":{_id:"104ad1f48518376",_name:"_Channel",_inherit:["_Component"],_core:!0,send:"event",$systemInstalled:"event",$systemResolved:"event",$systemStarted:"event",$systemStopped:"event",$systemUninstalled:"event"},"111df11e2b19fde":{_id:"111df11e2b19fde",_name:"_Component",_inherit:[],_core:!0,on:"method",off:"method",require:"method",destroy:"method",init:"method",error:"event"},"1723516a30132ac":{_name:"_Database",_inherit:["_Component"],_core:!0,collections:"method",insert:"event",update:"event",remove:"event",_id:"1723516a30132ac"},"1268f1dddd1fea7":{_name:"_Logger",_core:!0,level:"property",debug:"method",info:"method",warn:"method",error:"method",_id:"1268f1dddd1fea7"},"14caa1c46414ee1":{_name:"_Message",_inherit:["_Component"],_core:!0,event:"property",from:"property",data:"property",_id:"14caa1c46414ee1"},"193f1166eb16609":{_name:"_Metamodel",_inherit:["_Component"],_core:!0,schema:"method",model:"method",type:"method",create:"method",_id:"193f1166eb16609"},"157931f7a31b61d":{_id:"157931f7a31b61d",_name:"_OSGi",_inherit:["_Component"],_core:!0,install:"method",uninstall:"method",start:"method",stop:"method",status:"method",bundle:"method"},"12e211d4cd120a6":{_id:"12e211d4cd120a6",_name:"_Runtime",_inherit:["_OSGi"],_core:!0,version:"property",system:"method",message:"method",ready:"event"},"1cb761fa4510dca":{_id:"1cb761fa4510dca",_name:"_System",_inherit:["_SystemOSGi"],_core:!0,name:"property",master:"property",version:"property",description:"property",schemas:"property",models:"property",behaviors:"property",types:"property",components:"property"},"145fe10c7514298":{_id:"145fe10c7514298",_name:"_SystemOSGi",_inherit:["_Component"],_core:!0,state:"property",location:"property",start:"method",stop:"method"},"e018483e-4254-455c-83e9-99bb8dc3b233":{_id:"e018483e-4254-455c-83e9-99bb8dc3b233",_name:"_History",_core:!0,_inherit:["_Component"],back:"method",forward:"method",from:"method",dump:"method",get:"method",load:"method",start:"method",stop:"method",clear:"method"}},models:{"166971fd9d107fd":{_name:"_Behavior",_core:!0,context:{type:"any",readOnly:!1,mandatory:!1,default:null},core:{type:"boolean",readOnly:!1,mandatory:!1,default:!1},useCoreAPI:{type:"any",readOnly:!1,mandatory:!1,default:!1},component:{type:"string",readOnly:!1,mandatory:!0,default:""},action:{type:"javascript",readOnly:!1,mandatory:!0,default:""},state:{type:"string",readOnly:!1,mandatory:!0,default:""},_id:"166971fd9d107fd"},"135c71078810af2":{_id:"135c71078810af2",_name:"_Channel",_core:!0,send:{params:[{name:"message",type:"message"}]},$systemInstalled:{params:[{name:"id",type:"string",mandatory:!0,default:""}]},$systemResolved:{params:[{name:"id",type:"string",mandatory:!0,default:""}]},$systemUninstalled:{params:[{name:"id",type:"string",mandatory:!0,default:""}]},$systemStarted:{params:[{name:"id",type:"string",mandatory:!0,default:""}]},$systemStopped:{params:[{name:"id",type:"string",mandatory:!0,default:""}]}},"123751cb591de26":{_id:"123751cb591de26",_name:"_Component",_core:!0,on:{params:[{name:"state",type:"string"},{name:"action",type:"function"},{name:"useCoreAPI",type:"any",mandatory:!1,default:!1},{name:"isCore",type:"boolean",mandatory:!1,default:!1}]},off:{params:[{name:"state",type:"string",mandatory:!1},{name:"behaviorId",type:"string",mandatory:!1}]},require:{params:[{name:"id",type:"string"}]},destroy:{params:[]},init:{params:[{name:"document",type:"object"}]},error:{params:[{name:"e",type:"errorInfo"}]}},"18a51169d7112d4":{_name:"_Database",_core:!0,collections:{result:"object"},insert:{params:[{name:"event",type:"dbInsertEvent"}]},update:{params:[{name:"event",type:"dbUpdateEvent"}]},remove:{params:[{name:"event",type:"dbRemoveEvent"}]},_id:"18a51169d7112d4"},"16b9d1ac2216ffe":{_id:"16b9d1ac2216ffe",_name:"_Logger",_core:!0,level:{type:"log",readOnly:!1,mandatory:!1,default:"warn"},debug:{params:[{name:"message",type:"any"}]},info:{params:[{name:"message",type:"any"}]},warn:{params:[{name:"message",type:"any"}]},error:{params:[{name:"message",type:"any"}]}},"1d9b6139411aa91":{_name:"_Message",_core:!0,event:{type:"string",readOnly:!1,mandatory:!0,default:""},from:{type:"string",readOnly:!1,mandatory:!0,default:""},data:{type:"array",readOnly:!1,mandatory:!0,default:[]},_id:"1d9b6139411aa91"},"1628c13c22152e6":{_name:"_Metamodel",_core:!0,schema:{params:[{name:"name",type:"any",default:"",mandatory:!1},{name:"schema",type:"object",default:{},mandatory:!1}],result:"any"},model:{params:[{name:"name",type:"any",default:"",mandatory:!1},{name:"model",type:"object",default:{},mandatory:!1}],result:"any"},type:{params:[{name:"name",type:"any",default:"",mandatory:!1},{name:"type",type:"object",default:{},mandatory:!1}],result:"any"},create:{params:[]},_id:"1628c13c22152e6"},"100b91ed2211b15":{_id:"100b91ed2211b15",_name:"_OSGi",install:{params:[{name:"url",type:"any",mandatory:!0,default:""},{name:"async",type:"boolean",mandatory:!1,default:!0}],result:"string"},uninstall:{params:[{name:"id",type:"string",mandatory:!0,default:""}]},start:{params:[{name:"id",type:"string",mandatory:!0,default:""}]},stop:{params:[{name:"id",type:"string",mandatory:!0,default:""}]},status:{result:"object"},_core:!0,bundle:{result:"string"}},"14c7c105b31a160":{_id:"14c7c105b31a160",_name:"_Runtime",_core:!0,version:{type:"string",readOnly:!0,mandatory:!0,default:"6.0.0-beta.2"},system:{params:[{name:"params",type:"any",mandatory:!1}],result:"object"},message:{params:[{name:"msg",type:"message",mandatory:!0}]},ready:{}},"170521b88614387":{_name:"_System",_core:!0,name:{type:"string",readOnly:!1,mandatory:!0,default:""},master:{type:"boolean",readOnly:!1,mandatory:!1,default:!1},version:{type:"string",readOnly:!1,mandatory:!1,default:"0.0.1"},description:{type:"string",readOnly:!1,mandatory:!1,default:""},schemas:{type:"object",readOnly:!1,mandatory:!1,default:{}},models:{type:"object",readOnly:!1,mandatory:!1,default:{}},behaviors:{type:"object",readOnly:!1,mandatory:!1,default:{}},types:{type:"object",readOnly:!1,mandatory:!1,default:{}},components:{type:"object",readOnly:!1,mandatory:!1,default:{}},_id:"170521b88614387"},"1b2811b092143f5":{_id:"1b2811b092143f5",_name:"_SystemOSGi",start:{},stop:{},_core:!0,state:{type:"string",readOnly:!1,mandatory:!1,default:"none"},location:{type:"string",readOnly:!1,mandatory:!1,default:""}},"bd8d7e02-cd1f-4e4e-857f-077d6425cc1a":{_id:"bd8d7e02-cd1f-4e4e-857f-077d6425cc1a",_name:"_History",_description:"",back:{result:"number"},forward:{result:"number"},dump:{result:"string"},_core:!0,from:{params:[{name:"index",type:"number",mandatory:!0,default:-1}],result:"any"},get:{params:[{name:"index",type:"number",mandatory:!0,default:-1}],result:"object"},load:{params:[{name:"dump",type:"any",mandatory:!0,default:""}],result:"boolean"},start:{result:"any"},stop:{result:"any"},clear:{result:"any"}}},behaviors:{"12e491859c13918":{_id:"12e491859c13918",component:"_Channel",state:"$systemStarted",action:"function $systemStarted(id) { \n  let systems = null;\n    \n  if (id !== 'e89c617b6b15d24') {\n    if (typeof document !== 'undefined') {\n      systems = document.querySelectorAll('link[rel=system]');\n         \n      if ($state.get('runtime') && $state.get('runtime').state === 'ready') {    \n      } else {\n        if (systems.length + 1 === $db.collections._System.count()) {\n          $component.get('runtime').ready();\n        }\n      }\n    }\n  }\n}",useCoreAPI:!0,core:!0},"1e9021bd4e1bc6e":{_id:"1e9021bd4e1bc6e",component:"_Channel",state:"$systemInstalled",action:"function $systemInstalled(id) {\n  let systems = null,\n    dependencies = [],\n    master = [],\n    canStart = true;\n\n  if (id !== 'e89c617b6b15d24') {\n    // if all systems are installed\n    systems = $db.collections._System.find({});\n\n    systems.forEach(function (system) {\n      let sys = this.require(system._id);\n      if (sys && sys.state && sys.state() === 'none') {\n        canStart = false;\n      }\n    }.bind(this));\n\n    // start all the systems\n    if (canStart) {\n      dependencies = $db.collections._System.find({\n        'master': false\n      });\n\n      dependencies.forEach(function (dep) {\n        let system = this.require(dep._id);\n        channel = this.require('channel');\n\n        if (system.state() === 'resolved') {\n          system.state('starting');\n          system.start();\n          channel.$systemStarted(dep._id);\n          system.state('active');\n        }\n      }.bind(this));\n\n      master = $db.collections._System.find({\n        'master': true\n      });\n\n      master.forEach(function (dep) {\n        let system = this.require(dep._id);\n        channel = this.require('channel');\n\n        if (system && system.state && system.state() === 'resolved') {\n          system.state('starting');\n          system.start();\n          channel.$systemStarted(dep._id);\n          system.state('active');\n        }\n      }.bind(this));\n    }\n  }\n}",useCoreAPI:!0,core:!0},"1ba721201114b6b":{_id:"1ba721201114b6b",component:"_Component",state:"destroy",action:"function destroy() {\n  $component.destroy(this.id());\n}",core:!0,useCoreAPI:!0},"15486186f41a48c":{_id:"15486186f41a48c",component:"_Component",state:"off",action:'function off(state, behaviorId) {\n  let args = [],\n    i = 0,\n    numInjectedParams = 9,\n    length = arguments.length;\n\n  if ($helper.isOnNode()) {\n    numInjectedParams = numInjectedParams +1;\n  }\n\n  for (i = 0; i < length - numInjectedParams; i++) {\n    args.push(arguments[i]);\n  }\n\n  if ($workflow.checkInput({\n    "component": this,\n    "methodName": "off",\n    "args": args\n  })) {\n\n    if (state || behaviorId) {\n      if ($metamodel.isValidState(state, this.constructor.name)) {\n        $behavior.remove({\n          "behaviorId": behaviorId,\n          "componentId": this.id(),\n          "state": state\n        });\n      } else {\n        this.require(\'logger\').warn("invoke \\\'off\\\' method of component \'" + this.id() + "\' with an invalid state \'" + state + "\'");\n      }\n    } else {\n      $behavior.remove({\n        "componentId": this.id()\n      });\n    }\n  }\n}',core:!0,useCoreAPI:!0},"1da0a17878104c3":{_id:"1da0a17878104c3",component:"_Component",state:"require",action:"function require(id) {\n  return $component.get(id);\n}",core:!0,useCoreAPI:!0},"1a5111d17a1800c":{_id:"1a5111d17a1800c",component:"_Database",state:"collections",action:"function collections() {\n  let result = {},\n    collectionName = '';\n\n  for (collectionName in $db.store) {\n    if ($db.store.hasOwnProperty(collectionName)) {\n      result[collectionName] = $db.collections[collectionName];\n    }\n  }\n  return result;\n}",core:!0,useCoreAPI:!0},"1d993108fa18ef2":{_id:"1d993108fa18ef2",component:"_Logger",state:"debug",action:"function debug(message) {\n  if (this.level() === 'debug') {\n    console.log('runtime: ' + message);\n  }\n}",core:!0},"1a37a188e11fe73":{_id:"1a37a188e11fe73",component:"_Logger",state:"error",action:"function error(message) {\n  if (this.level() === 'info' || this.level() === 'warn' || this.level() === 'debug' || this.level() === 'error') {\n    console.error('runtime: ' + message);\n  }\n}",core:!0},"1edd21e12a16534":{_id:"1edd21e12a16534",component:"_Logger",state:"info",action:"function info(message) {\n  if (this.level() === 'info' || this.level() === 'debug') {\n    console.info('runtime: ' + message);\n  }\n}",core:!0},"141f2143d3122a4":{_id:"141f2143d3122a4",component:"_Logger",state:"level",action:"function level(val) {\n  $log.level(val);\n}",core:!0,useCoreAPI:!0},"192401bab21304e":{_id:"192401bab21304e",component:"_Logger",state:"warn",action:"function warn(message) {\n  if (this.level() === 'info' || this.level() === 'warn' || this.level() === 'debug') {\n    console.warn('runtime: ' + message);\n  }\n}",core:!0},"11fc715e2f1a31e":{_id:"11fc715e2f1a31e",component:"_Metamodel",state:"create",action:"function create() {\n  $metamodel.create();\n}",core:!0,useCoreAPI:!0},"1232f1f107142cf":{_id:"1232f1f107142cf",component:"_Metamodel",state:"model",action:"function model(name, model) {\n  return $metamodel.model(name, model);\n}",core:!0,useCoreAPI:!0},"1365412f69153d2":{_id:"1365412f69153d2",component:"_Metamodel",state:"schema",action:"function schema(name, schema) {\n  return $metamodel.schema(name, schema);\n}",core:!0,useCoreAPI:!0},"194db147fe161a2":{_id:"194db147fe161a2",component:"_Metamodel",state:"type",action:"function type(name, type) {\n  return $metamodel.type(name, type);\n}",core:!0,useCoreAPI:!0},"1ef951f1411b895":{_id:"1ef951f1411b895",component:"_OSGi",state:"install",action:"function install(url, async) {\n  let importedSystem = null,\n    system = {},\n    systemId = '',\n    callbackLoad = null,\n    xhr = null,\n    result = '',\n    channel = $component.get('channel');\n\n  if (typeof url === 'object') {\n    importedSystem = url;\n  } else {\n    if (url.indexOf('{') === 0) {\n      importedSystem = JSON.parse(url);\n    }\n  }\n\n  if (importedSystem) {\n    systemId = $db.importSystem(importedSystem);\n    if (systemId) {\n      system = this.require(systemId);\n\n      if (typeof url === 'string') {\n        system.location(url);\n      }\n      system.state('installed');\n      channel.$systemInstalled(systemId);\n      system.state('resolved');\n      channel.$systemResolved(systemId);\n\n      result = systemId;\n    }\n  } else {\n    xhr = new XMLHttpRequest();\n    callbackLoad = function callbackLoad(system, url) {\n      let sysId = $db.importSystem(system),\n        sys = $component.get(sysId),\n        channel = $component.get('channel');\n\n      if (typeof url === 'string') {\n        sys.location(url);\n      }\n      sys.state('installed');\n      channel.$systemInstalled(sysId);\n      sys.state('resolved');\n      channel.$systemResolved(sysId);\n\n      result = sysId;\n    };\n\n    if (async) {\n      xhr.open('GET', url, true);\n      xhr.onreadystatechange = function () {\n        if (xhr.readyState === 4) {\n          if (xhr.status === 200 || xhr.status === 0) {\n            if (xhr.response !== '') {\n              callbackLoad(JSON.parse(xhr.response), url);\n            }\n          }\n        }\n      };\n      xhr.send(null);\n    } else {\n      xhr.open('GET', url, false);\n      xhr.send(null);\n      if (xhr.status === 200 || xhr.status === 0) {\n        callbackLoad(JSON.parse(xhr.response), url);\n      }\n    }\n  }\n  return result;\n}",useCoreAPI:!0,core:!0},"14c1517b711cb78":{_id:"14c1517b711cb78",component:"_OSGi",state:"uninstall",action:"function uninstall(id) {\n  let search = {},\n    system = null,\n    behaviorId = '',\n    collection = '',\n    componentId = '',\n    length = 0,\n    i = 0,\n    coreComponents = ['admin', 'channel', 'db', 'logger', 'metamodel', 'runtime'];\n\n  search = $db.collections._System.find({\n    '_id': id\n  });\n\n  if (search.length) {\n    system = search[0];\n    // remove behaviors\n    if (system.behaviors) {\n      for (behaviorId in system.behaviors) {\n        $db.collections._Behavior.remove({\n          '_id': system.behaviors[behaviorId]._id\n        });\n      }\n    }\n    // remove components\n    if (system.components) {\n      for (collection in system.components) {\n        for (componentId in system.components[collection]) {\n          if (coreComponents.indexOf(componentId) === -1) {\n            $db.collections[collection].remove({\n              '_id': componentId\n            });\n          }\n        }\n      }\n    }\n  }\n  if (this.require(id) && this.require(id).state) {\n    this.require(id).state('uninstalled');\n    this.require('channel').$systemUninstalled(id);\n  }\n}",useCoreAPI:!0,core:!0},"105f219c6813643":{_id:"105f219c6813643",component:"_OSGi",state:"start",action:"function start(id) {\n  let system = this.require(id),\n    channel = this.require('channel');\n\n  if (system && system.state() === 'resolved' || system.state() === 'installed') {\n    system.state('starting');\n    if (system.start) {\n      system.start();\n    }\n    channel.$systemStarted(id);\n    system.state('active');\n  }\n}",useCoreAPI:!1,core:!0},"1a81a1f00d17269":{_id:"1a81a1f00d17269",component:"_OSGi",state:"stop",action:"function stop(id) {\n  let system = this.require(id),\n    channel = this.require('channel');\n\n  if (system && system.state() === 'active') {\n    system.state('stopping');\n    if (system.stop) {\n      system.stop();\n    }\n    channel.$systemStopped(id);\n    system.state('resolved');\n    channel.$systemResolved(id);\n  }\n}",useCoreAPI:!1,core:!0},"116851b602128d1":{_id:"116851b602128d1",component:"_OSGi",state:"status",action:"function status() {\n  let result = {},\n    system = null,\n    length = 0,\n    i = 0;\n\n  systems = $db.collections._System.find({});\n\n  length = systems.length;\n  for (i = 0; i < length; i++) {\n    system = systems[i];\n    result[system.name] = {\n      'id': system._id,\n      'state': system.state,\n      'name': system.name,\n      'version': system.version,\n      'location': system.location,\n      'master': system.master\n    };\n  }\n\n  return result;\n}",useCoreAPI:!0,core:!0},"19cf317d7217331":{_id:"19cf317d7217331",component:"_OSGi",state:"bundle",action:"function bundle() { \n\tlet result = $db.exportSystem();\n\treturn result;\n}",useCoreAPI:!0,core:!0},"13010167f313f87":{_id:"13010167f313f87",component:"_Runtime",state:"system",action:"function system(params) {\n  let RuntimeSystem = null,\n    system = {},\n    systemId = '',\n    result = [],\n    conf = {};\n\n  if (params) {\n    if (typeof params === 'string') {\n      conf.master = true;\n      conf.name = params;\n    } else {\n      conf = params;\n      conf.master = true;\n    }\n    RuntimeSystem = this.require('_System');\n    system = new RuntimeSystem(conf);\n    system.state('active');\n  } else {\n    result = $db.collections._System.find({\n      'master': true\n    });\n    if (result.length) {\n      systemId = result[0]._id;\n      system = $component.get(systemId);\n    }\n  }\n  return system;\n}",core:!0,useCoreAPI:!0},"1cfa4145f614da8":{_id:"1cfa4145f614da8",component:"_Runtime",state:"message",action:"function message(msg) { \n  $db.collections._Message.insert(msg);\n}",useCoreAPI:!0,core:!0},"1cb9d103d41dd97":{_id:"1cb9d103d41dd97",component:"e89c617b6b15d24",state:"start",action:"function start() {\n  if (typeof document !== 'undefined') {\n    document.addEventListener('DOMContentLoaded', function DOMContentLoaded(e) {\n      let systems = [],\n        system = null,\n        scripts = [],\n        script = null,\n        logLevel = 'warn',\n        i = 0,\n        length = 0;\n    \n      systems = document.querySelectorAll('link[rel=system]');\n      length = systems.length;\n  \n      // logger\n      scripts = document.querySelectorAll('script[log]');\n      if (scripts.length) {\n        logLevel = scripts[0].getAttribute('log');\n        this.require('logger').level(logLevel);\n      }\n  \n      // systems\n      for (i = 0; i < length; i++) {\n        system = systems[i];\n  \n        if (system.getAttribute('async') === 'false') {\n          this.require('runtime').install(system.href, false);\n        } else {\n          this.require('runtime').install(system.href, true);\n        }\n      }\n  \n      // ready event\n      if (length === 0) {\n        this.require('runtime').ready();\n      }\n  }.bind(this));\n  }\n}",useCoreAPI:!0,core:!0},"e2848b60-99a1-472f-b0e1-5923077f6c61":{_id:"e2848b60-99a1-472f-b0e1-5923077f6c61",component:"_History",state:"back",action:"function back() { \n  return $history.back();\n}",useCoreAPI:!0,core:!0},"cebc40ad-c704-405c-b499-e60390b1bb82":{_id:"cebc40ad-c704-405c-b499-e60390b1bb82",component:"_History",state:"forward",action:"function forward() { \n  return $history.forward();\n}",useCoreAPI:!0,core:!0},"c35af0df-2fc6-4af5-a476-4f2ee089c30e":{_id:"c35af0df-2fc6-4af5-a476-4f2ee089c30e",component:"_History",state:"dump",action:"function dump() { \n  return $history.dump();\n}",useCoreAPI:!0,core:!0},"f06254ad-187e-400c-a582-b5ab81f24747":{_id:"f06254ad-187e-400c-a582-b5ab81f24747",component:"_History",state:"get",action:"function get(index) { \n  return $history.get(index);\n}",useCoreAPI:!0,core:!0},"aa731445-8d7c-4dd7-a78f-5dd70f750f87":{_id:"aa731445-8d7c-4dd7-a78f-5dd70f750f87",component:"_History",state:"from",action:"function from(index) { \n  return $history.from(index);\n}",useCoreAPI:!0,core:!0},"f565e46e-daee-492d-99ca-d9ed123132ba":{_id:"f565e46e-daee-492d-99ca-d9ed123132ba",component:"_History",state:"load",action:"function load(dump) { \n  return $history.load(dump);\n}",useCoreAPI:!0,core:!0},"d3827b91-f6db-46d9-833e-351564cb6e91":{_id:"d3827b91-f6db-46d9-833e-351564cb6e91",component:"_History",state:"start",action:"function start() { \n  return $history.start();\n}",useCoreAPI:!0,core:!0},"aa3b13ab-8b69-4962-bc44-e975cd42a206":{_id:"aa3b13ab-8b69-4962-bc44-e975cd42a206",component:"_History",state:"stop",action:"function stop() { \n  return $history.stop();\n}",useCoreAPI:!0,core:!0},"b112782c-3633-443e-8d7a-8d379b44e32d":{_id:"b112782c-3633-443e-8d7a-8d379b44e32d",component:"_History",state:"clear",action:"function clear() { \n  return $history.clear();\n}",useCoreAPI:!0,core:!0}},types:{css:{_id:"h1d88311ac019211",name:"css",type:"string",core:!0},date:{_id:"c17cad1bc3d17752",name:"date",type:"object",core:!0},json:{_id:"e1d25a12e67127ed",name:"json",type:"object",core:!0},dbInsertEvent:{_id:"148ef1e19810e6d",core:!0,name:"dbInsertEvent",type:"object",schema:{collection:{type:"string",mandatory:!0,default:""},document:{type:"object",mandatory:!0,default:{}}}},dbRemoveEvent:{_id:"1952e1ac4213f4a",name:"dbRemoveEvent",type:"object",core:!0,schema:{collection:{type:"string",mandatory:!0,default:""},id:{type:"string",mandatory:!0,default:""}}},dbUpdateEvent:{_id:"1f5c41309711752",core:!0,name:"dbUpdateEvent",type:"object",schema:{collection:{type:"string",mandatory:!0,default:""},id:{type:"string",mandatory:!0,default:""},field:{type:"string",mandatory:!0,default:""},value:{type:"any",mandatory:!0,default:null}}},collection:{_id:"d1c0d0130c616199",name:"collection",type:"object",schema:{type:{type:["string"],mandatory:!0},readOnly:{type:"boolean",mandatory:!0},mandatory:{type:"boolean",mandatory:!0},default:{type:"array",mandatory:!0},description:{type:"string",mandatory:!1},label:{type:"string",mandatory:!1},kind:{type:"string",mandatory:!1}},core:!0},event:{_id:"g1668d1de2d1ff6f",name:"event",type:"object",schema:{params:{type:["parameter"],mandatory:!1},description:{type:"string",mandatory:!1}},core:!0},html:{_id:"y161c21320b11acb",name:"html",type:"string",core:!0},javascript:{_id:"s13d4c1fdf916504",name:"javascript",type:"string",core:!0},link:{_id:"p124601801d1dbfa",name:"link",type:"object",schema:{type:{type:"string",mandatory:!0},readOnly:{type:"boolean",mandatory:!0},mandatory:{type:"boolean",mandatory:!0},default:{type:"{type}",mandatory:!0},description:{type:"string",mandatory:!1},label:{type:"string",mandatory:!1},kind:{type:"string",mandatory:!1}},core:!0},log:{_id:"d1fd161a4a4149fc",name:"log",type:"string",value:["debug","info","warn","error","off"],core:!0},message:{_id:"l13b061ac571272d",name:"message",type:"object",schema:{event:{type:"string",mandatory:!0},from:{type:"string",mandatory:!1},data:{type:"array",mandatory:!0}},core:!0},method:{_id:"x1227218eed1f3e9",name:"method",type:"object",schema:{result:{type:"any",mandatory:!1},params:{type:["parameter"],mandatory:!1},description:{type:"string",mandatory:!1}},core:!0},osgiStates:{_id:"q1f0ca120fc13fb3",name:"osgiStates",type:"string",value:["none","installed","resolved","starting","active","stopping","uninstalled"],core:!0},parameter:{_id:"e1b18e16c6c195ad",name:"parameter",type:"object",schema:{description:{type:"string",mandatory:!1},name:{type:"string",mandatory:!0},type:{type:"any",mandatory:!0},mandatory:{type:"boolean",mandatory:!1},default:{type:"{type}",mandatory:!1}},core:!0},property:{_id:"a16a3a1ae051a55d",name:"property",type:"object",schema:{type:{type:"string",mandatory:!0},readOnly:{type:"boolean",mandatory:!0},mandatory:{type:"boolean",mandatory:!0},default:{type:"{type}",mandatory:!0},description:{type:"string",mandatory:!1},label:{type:"string",mandatory:!1}},core:!0},text:{_id:"c136fc129a912f54",name:"text",type:"string",core:!0},errorInfo:{_id:"e198761fc0b1ae8a",name:"errorInfo",type:"object",schema:{message:{type:"string",mandatory:!0},stack:{type:"object",mandatory:!0}},core:!0}},components:{_Channel:{channel:{_id:"channel"}},_Database:{db:{_id:"db"}},_Logger:{logger:{_id:"logger",level:"warn"}},_Metamodel:{metamodel:{_id:"metamodel"}},_Runtime:{runtime:{_id:"runtime",version:"6.0.0-beta.2"}},_History:{history:{_id:"history"}}},_id:"e89c617b6b15d24"}),xe=fe.get(Ae),Me=fe.get("channel"),xe.state("installed"),Me.$systemInstalled(Ae),xe.state("resolved"),Me.$systemResolved(Ae),xe.state("starting"),Me.$systemStarted(Ae),xe.start(),xe.state("active");const Ce=fe.get("runtime");export{Ce as default};
//# sourceMappingURL=system-runtime.js.map
